"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function wordCount(lines) {
    return lines
        .map((s) => s.toLowerCase())
        .flatMap(function* (line) {
        yield* line.split(/[^a-z]+/);
    })
        .apply(countPerElement());
}
var _tct_transform_1, _tct_transform_2, _tct_transform_3;
wordCount.__closure = () => ({ countPerElement });
async function main() {
    await createRunner(yargs.argv).run((_tct_transform_1 = (root) => {
        const lines = root.apply(beam.create([
            "In the beginning God created the heaven and the earth.",
            "And the earth was without form, and void; and darkness was upon the face of the deep.",
            "And the Spirit of God moved upon the face of the waters.",
            "And God said, Let there be light: and there was light.",
        ]));
        lines.apply(wordCount).map(console.log);
    }, _tct_transform_1.__closure = () => ({ beam, wordCount, console }), _tct_transform_1));
}
main.__closure = () => ({ createRunner, yargs, beam, wordCount, console });
Object.defineProperty(exports, "__esModule", { value: true });
// Run directly with
//
//    node dist/src/apache_beam/examples/wordcount.js
//
// A different runner can be chosen via a --runner argument, e.g.
//
//    node dist/src/apache_beam/examples/wordcount.js --runner=flink
//
// To run on Dataflow, pass the required arguments:
//
//    node dist/src/apache_beam/examples/wordcount.js --runner=dataflow --project=PROJECT_ID --tempLocation=gs://BUCKET/DIR' --region=us-central1
// TODO: Should this be in a top-level examples dir, rather than under apache_beam?
const _tct_flatten_destructured_imports_1 = __importStar(require("yargs"));
var yargs = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../../apache_beam"));
var beam = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("../runners/runner"));
var createRunner = _tct_flatten_destructured_imports_3.createRunner;
const _tct_flatten_destructured_imports_4 = __importStar(require("../transforms/group_and_combine"));
var countPerElement = _tct_flatten_destructured_imports_4.countPerElement;
main()
    .catch((_tct_transform_2 = (e) => console.error(e), _tct_transform_2.__closure = () => ({ console }), _tct_transform_2))
    .finally((_tct_transform_3 = () => process.exit(), _tct_transform_3.__closure = () => ({ process }), _tct_transform_3));
//# sourceMappingURL=wordcount.js.map