"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
// TODO: Schema-producing variants.
function readFromPubSub(options) {
    if (options.topic && options.subscription) {
        throw new TypeError("Exactly one of topic or subscription must be provided.");
    }
    return withName("readFromPubSubRaw", external.rawExternalTransform("beam:transform:org.apache.beam:pubsub_read:v1", camelToSnakeOptions(options), serviceProviderFromJavaGradleTarget(PUBSUB_EXPANSION_GRADLE_TARGET)));
}
var _tct_transform_1, _tct_transform_2;
readFromPubSub.__closure = () => ({ TypeError, withName, external, camelToSnakeOptions, serviceProviderFromJavaGradleTarget, PUBSUB_EXPANSION_GRADLE_TARGET });
function readFromPubSubWithAttributesRaw(options) {
    if (options.topic && options.subscription) {
        throw new TypeError("Exactly one of topic or subscription must be provided.");
    }
    return withName("readFromPubSubWithAttributesRaw", external.rawExternalTransform("beam:transform:org.apache.beam:pubsub_read:v1", { needsAttributes: true, ...camelToSnakeOptions(options) }, serviceProviderFromJavaGradleTarget(PUBSUB_EXPANSION_GRADLE_TARGET)));
}
readFromPubSubWithAttributesRaw.__closure = () => ({ TypeError, withName, external, camelToSnakeOptions, serviceProviderFromJavaGradleTarget, PUBSUB_EXPANSION_GRADLE_TARGET });
function readFromPubSubWithAttributes(options) {
    return _tct_transform_1 = async function readFromPubSubWithAttributes(root) {
        var _tct_transform_3;
        return (await root.applyAsync(readFromPubSubWithAttributesRaw(options))).map((_tct_transform_3 = (encoded) => PubSub.protos.google.pubsub.v1.PubsubMessage.decode(encoded), _tct_transform_3.__closure = () => ({ PubSub }), _tct_transform_3));
    }, _tct_transform_1.__closure = () => ({ readFromPubSubWithAttributesRaw, options, PubSub }), _tct_transform_1;
}
readFromPubSubWithAttributes.__closure = () => ({ readFromPubSubWithAttributesRaw, PubSub });
function writeToPubSubRaw(topic, options = {}) {
    return withName("writeToPubSubRaw", external.rawExternalTransform("beam:transform:org.apache.beam:pubsub_write:v1", { topic, ...camelToSnakeOptions(options) }, serviceProviderFromJavaGradleTarget(PUBSUB_EXPANSION_GRADLE_TARGET)));
}
writeToPubSubRaw.__closure = () => ({ withName, external, camelToSnakeOptions, serviceProviderFromJavaGradleTarget, PUBSUB_EXPANSION_GRADLE_TARGET });
function writeToPubSub(topic, options = {}) {
    return _tct_transform_2 = async function writeToPubSub(dataPColl) {
        var _tct_transform_4;
        return dataPColl //
            .map((_tct_transform_4 = (data) => PubSub.protos.google.pubsub.v1.PubsubMessage.encode({ data }).finish(), _tct_transform_4.__closure = () => ({ PubSub }), _tct_transform_4))
            .apply(internal.withCoderInternal(new BytesCoder()))
            .applyAsync(writeToPubSubRaw(topic, options));
    }, _tct_transform_2.__closure = () => ({ PubSub, internal, BytesCoder, writeToPubSubRaw, topic, options }), _tct_transform_2;
}
writeToPubSub.__closure = () => ({ PubSub, internal, BytesCoder, writeToPubSubRaw });
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeToPubSub = exports.readFromPubSubWithAttributes = exports.readFromPubSub = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("@google-cloud/pubsub"));
var PubSub = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../pvalue"));
var beam = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("../transforms/external"));
var external = _tct_flatten_destructured_imports_3;
const _tct_flatten_destructured_imports_4 = __importStar(require("../transforms/internal"));
var internal = _tct_flatten_destructured_imports_4;
const _tct_flatten_destructured_imports_5 = __importStar(require("../transforms/transform"));
var AsyncPTransform = _tct_flatten_destructured_imports_5.AsyncPTransform;
var withName = _tct_flatten_destructured_imports_5.withName;
const _tct_flatten_destructured_imports_6 = __importStar(require("../coders/row_coder"));
var RowCoder = _tct_flatten_destructured_imports_6.RowCoder;
const _tct_flatten_destructured_imports_7 = __importStar(require("../coders/required_coders"));
var BytesCoder = _tct_flatten_destructured_imports_7.BytesCoder;
const _tct_flatten_destructured_imports_8 = __importStar(require("../utils/service"));
var serviceProviderFromJavaGradleTarget = _tct_flatten_destructured_imports_8.serviceProviderFromJavaGradleTarget;
const _tct_flatten_destructured_imports_9 = __importStar(require("../utils/utils"));
var camelToSnakeOptions = _tct_flatten_destructured_imports_9.camelToSnakeOptions;
const PUBSUB_EXPANSION_GRADLE_TARGET = "sdks:java:io:google-cloud-platform:expansion-service:shadowJar";
const readSchema = RowCoder.inferSchemaOfJSON({
    topic: "string",
    subscription: "string",
    idAttribute: "string",
    timestampAttribute: "string",
});
exports.readFromPubSub = readFromPubSub;
exports.readFromPubSubWithAttributes = readFromPubSubWithAttributes;
exports.writeToPubSub = writeToPubSub;
const _tct_flatten_destructured_imports_10 = __importStar(require("../serialization"));
var requireForSerialization = _tct_flatten_destructured_imports_10.requireForSerialization;
requireForSerialization("apache-beam/io/pubsub", PubSub);
//# sourceMappingURL=pubsub.js.map