"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function schemaio(name, urn, config, configSchema = undefined) {
    // Location is separate for historical reasons.
    let maybeLocation = {};
    if (config.location) {
        maybeLocation.location = config.location;
        delete config.location;
    }
    // Similarly for Schema, which is passed as bytes.
    let maybeSchema = {};
    if (config.schema) {
        maybeSchema.dataSchema = Schema.toBinary(config.schema);
        delete config.schema;
    }
    // The config is encoded and passed as bytes.
    const writer = new protobufjs.Writer();
    if (configSchema === undefined) {
        configSchema = RowCoder.inferSchemaOfJSON(config);
    }
    new RowCoder(configSchema).encode(config, writer, null);
    const encodedConfig = writer.finish();
    return beam.withName(name, external.rawExternalTransform(urn, { config: encodedConfig, ...maybeLocation, ...maybeSchema }, serviceProviderFromJavaGradleTarget("sdks:java:io:google-cloud-platform:expansion-service:shadowJar")));
}
schemaio.__closure = () => ({ Schema, protobufjs, RowCoder, beam, external, serviceProviderFromJavaGradleTarget });
Object.defineProperty(exports, "__esModule", { value: true });
exports.schemaio = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("../../apache_beam"));
var beam = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../transforms/external"));
var external = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("../proto/schema"));
var Schema = _tct_flatten_destructured_imports_3.Schema;
const _tct_flatten_destructured_imports_4 = __importStar(require("../coders/row_coder"));
var RowCoder = _tct_flatten_destructured_imports_4.RowCoder;
const _tct_flatten_destructured_imports_5 = __importStar(require("../utils/service"));
var serviceProviderFromJavaGradleTarget = _tct_flatten_destructured_imports_5.serviceProviderFromJavaGradleTarget;
const _tct_flatten_destructured_imports_6 = __importStar(require("protobufjs"));
var protobufjs = _tct_flatten_destructured_imports_6;
exports.schemaio = schemaio;
//# sourceMappingURL=schemaio.js.map