"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function fileArtifact(filePath, roleUrn, rolePayload = undefined) {
    const hasher = crypto.createHash("sha256");
    hasher.update(fs.readFileSync(filePath));
    return runnerApiProto.ArtifactInformation.create({
        typeUrn: "beam:artifact:type:file:v1",
        typePayload: runnerApiProto.ArtifactFilePayload.toBinary({
            path: path.resolve(filePath),
            sha256: hasher.digest("hex"),
        }),
        roleUrn: roleUrn,
        rolePayload: rolePayload,
    });
}
fileArtifact.__closure = () => ({ crypto, fs, runnerApiProto, path });
Object.defineProperty(exports, "__esModule", { value: true });
exports.PortableRunner = void 0;
const childProcess = require("child_process");
const crypto = require("crypto");
const fs = require("fs");
const os = require("os");
const path = require("path");
const _tct_flatten_destructured_imports_1 = __importStar(require("@grpc/grpc-js"));
var ChannelCredentials = _tct_flatten_destructured_imports_1.ChannelCredentials;
const _tct_flatten_destructured_imports_2 = __importStar(require("@protobuf-ts/grpc-transport"));
var GrpcTransport = _tct_flatten_destructured_imports_2.GrpcTransport;
const _tct_flatten_destructured_imports_3 = __importStar(require("../../proto/google/protobuf/struct"));
var Struct = _tct_flatten_destructured_imports_3.Struct;
const _tct_flatten_destructured_imports_4 = __importStar(require("../../proto/beam_runner_api"));
var runnerApiProto = _tct_flatten_destructured_imports_4;
const _tct_flatten_destructured_imports_5 = __importStar(require("../../proto/beam_job_api"));
var PrepareJobRequest = _tct_flatten_destructured_imports_5.PrepareJobRequest;
const _tct_flatten_destructured_imports_6 = __importStar(require("../../proto/beam_job_api.client"));
var JobServiceClient = _tct_flatten_destructured_imports_6.JobServiceClient;
const _tct_flatten_destructured_imports_7 = __importStar(require("../../proto/beam_artifact_api.client"));
var ArtifactStagingServiceClient = _tct_flatten_destructured_imports_7.ArtifactStagingServiceClient;
const _tct_flatten_destructured_imports_8 = __importStar(require("../../internal/pipeline"));
var Pipeline = _tct_flatten_destructured_imports_8.Pipeline;
const _tct_flatten_destructured_imports_9 = __importStar(require("../runner"));
var PipelineResult = _tct_flatten_destructured_imports_9.PipelineResult;
var Runner = _tct_flatten_destructured_imports_9.Runner;
const _tct_flatten_destructured_imports_10 = __importStar(require("../../options/pipeline_options"));
var PipelineOptions = _tct_flatten_destructured_imports_10.PipelineOptions;
const _tct_flatten_destructured_imports_11 = __importStar(require("../../proto/beam_job_api"));
var JobState_Enum = _tct_flatten_destructured_imports_11.JobState_Enum;
var JobStateEvent = _tct_flatten_destructured_imports_11.JobStateEvent;
const _tct_flatten_destructured_imports_12 = __importStar(require("../../proto/metrics"));
var MonitoringInfo = _tct_flatten_destructured_imports_12.MonitoringInfo;
const _tct_flatten_destructured_imports_13 = __importStar(require("../../worker/external_worker_service"));
var ExternalWorkerPool = _tct_flatten_destructured_imports_13.ExternalWorkerPool;
const _tct_flatten_destructured_imports_14 = __importStar(require("../../internal/environments"));
var environments = _tct_flatten_destructured_imports_14;
const _tct_flatten_destructured_imports_15 = __importStar(require("../artifacts"));
var artifacts = _tct_flatten_destructured_imports_15;
const _tct_flatten_destructured_imports_16 = __importStar(require("../../utils/service"));
var JobService = _tct_flatten_destructured_imports_16.Service;
const _tct_flatten_destructured_imports_17 = __importStar(require("../../serialization"));
var serialization = _tct_flatten_destructured_imports_17;
const _tct_flatten_destructured_imports_18 = __importStar(require("../../version"));
var version = _tct_flatten_destructured_imports_18.version;
const TERMINAL_STATES = [
    JobState_Enum.DONE,
    JobState_Enum.FAILED,
    JobState_Enum.CANCELLED,
    JobState_Enum.UPDATED,
    JobState_Enum.DRAINED,
];
const DOCKER_BASE = "docker.io/apache/beam_typescript_sdk";
class PortableRunnerPipelineResult extends PipelineResult {
    constructor(runner, jobId, completionCallbacks) {
        super();
        this.runner = runner;
        this.jobId = jobId;
        this.completionCallbacks = completionCallbacks;
    }
    static isTerminal(state) {
        return TERMINAL_STATES.includes(state);
    }
    async getState() {
        if (this.terminalState) {
            return this.terminalState;
        }
        const state = await this.runner.getJobState(this.jobId);
        if (PortableRunnerPipelineResult.isTerminal(state.state)) {
            this.terminalState = state;
            this.finalMetrics = await this.rawMetrics();
            for (const callback of this.completionCallbacks) {
                await callback(state);
            }
        }
        return state;
    }
    async cancel() {
        if (this.terminalState) {
            return;
        }
        const { state } = await this.runner.cancelJob(this.jobId);
        this.terminalState = { state };
        for (const callback of this.completionCallbacks) {
            await callback({ state });
        }
    }
    /**
     * Waits until the pipeline finishes and returns the final status.
     * @param duration timeout in milliseconds.
     */
    async waitUntilFinish(duration) {
        var _tct_transform_1;
        let { state } = await this.getState();
        const start = Date.now();
        let pollMillis = { value: undefined };
        pollMillis.value = 10;
        while (!PortableRunnerPipelineResult.isTerminal(state)) {
            const now = Date.now();
            if (duration !== undefined && now - start > duration) {
                return state;
            }
            pollMillis.value = Math.min(10000, pollMillis.value * 1.2);
            await new Promise((_tct_transform_1 = (r) => setTimeout(r, pollMillis.value), _tct_transform_1.__closure = () => ({ setTimeout, pollMillis }), _tct_transform_1));
            state = (await this.getState()).state;
        }
        return state;
    }
    async rawMetrics() {
        if (this.finalMetrics !== undefined) {
            return this.finalMetrics;
        }
        else {
            const metrics = await this.runner.getJobMetrics(this.jobId);
            return metrics.metrics.committed;
        }
    }
}
class PortableRunner extends Runner {
    constructor(options, jobService = undefined) {
        super();
        this.jobService = jobService;
        if (typeof options === "string") {
            this.defaultOptions = { jobEndpoint: options };
        }
        else if (options) {
            this.defaultOptions = options;
        }
    }
    async getClient() {
        if (!this.client) {
            if (this.jobService) {
                this.defaultOptions.jobEndpoint = await this.jobService.start();
            }
            this.client = new JobServiceClient(new GrpcTransport({
                host: this.defaultOptions?.jobEndpoint,
                channelCredentials: ChannelCredentials.createInsecure(),
            }));
        }
        return this.client;
    }
    async getJobMetrics(jobId) {
        const call = (await this.getClient()).getJobMetrics({ jobId });
        return await call.response;
    }
    async getJobState(jobId) {
        const call = (await this.getClient()).getState({ jobId });
        return await call.response;
    }
    async cancelJob(jobId) {
        const call = (await this.getClient()).cancel({ jobId });
        return await call.response;
    }
    async runPipeline(pipeline, options) {
        return this.runPipelineWithProto(pipeline, options);
    }
    async runPipelineWithProto(pipeline, options) {
        var _tct_transform_2, _tct_transform_3, _tct_transform_4;
        options = { ...this.defaultOptions, ...(options || {}) };
        for (const [_, pcoll] of Object.entries(pipeline.components.pcollections)) {
            if (pcoll.isBounded == runnerApiProto.IsBounded_Enum.UNBOUNDED) {
                options.streaming = true;
                break;
            }
        }
        const completionCallbacks = [];
        if (this.jobService) {
            const jobService = this.jobService;
            completionCallbacks.push((_tct_transform_2 = () => jobService.stop(), _tct_transform_2.__closure = () => ({ jobService }), _tct_transform_2));
        }
        let loopbackAddress = undefined;
        if (options?.environmentType === "LOOPBACK") {
            const workers = new ExternalWorkerPool();
            loopbackAddress = await workers.start();
            completionCallbacks.push((_tct_transform_3 = () => workers.stop(), _tct_transform_3.__closure = () => ({ workers }), _tct_transform_3));
        }
        // Replace the default environment according to the pipeline options.
        pipeline = runnerApiProto.Pipeline.clone(pipeline);
        for (const [envId, env] of Object.entries(pipeline.components.environments)) {
            if (env.urn === environments.TYPESCRIPT_DEFAULT_ENVIRONMENT_URN) {
                if (loopbackAddress) {
                    pipeline.components.environments[envId] =
                        environments.asExternalEnvironment(env, loopbackAddress);
                }
                else {
                    // Create a docker environment.
                    pipeline.components.environments[envId] =
                        environments.asDockerEnvironment(env, options?.sdkContainerImage ||
                            DOCKER_BASE + ":" + version.replace("-SNAPSHOT", ".dev"));
                    const deps = pipeline.components.environments[envId].dependencies;
                    // Package up this code as a dependency.
                    const tmpDir = fs.mkdtempSync(path.join(os.tmpdir(), "beam-pack-"));
                    const result = childProcess.spawnSync("npm", ["pack", "--pack-destination", tmpDir], {
                        encoding: "latin1",
                    });
                    if (result.status === 0) {
                        console.debug(result.stdout);
                    }
                    else {
                        throw new Error(result.output);
                    }
                    const packFile = path.resolve(path.join(tmpDir, result.stdout.trim()));
                    deps.push(fileArtifact(packFile, "beam:artifact:type:npm:v1"));
                    // If any dependencies are files, package them up as well.
                    if (fs.existsSync("package.json")) {
                        const packageData = JSON.parse(fs.readFileSync("package.json"));
                        if (packageData.dependencies) {
                            for (const dep in packageData.dependencies) {
                                if (packageData.dependencies[dep].startsWith("file:")) {
                                    const path = packageData.dependencies[dep].substring(5);
                                    deps.push(fileArtifact(path, "beam:artifact:type:npm_dep:v1", new TextEncoder().encode(dep)));
                                }
                            }
                        }
                    }
                }
            }
        }
        // Note the set of modules that need to be imported in the worker.
        options.registeredNodeModules =
            serialization.getRegisteredModules();
        // Inform the runner that we'd like to execute this pipeline.
        console.debug("Preparing job.");
        let message = {
            pipeline,
            jobName: options?.jobName || "",
        };
        if (options) {
            const camel_to_snake = (option) => option.replace(/[A-Z]/g, (letter) => `_${letter.toLowerCase()}`);
            message.pipelineOptions = Struct.fromJson(Object.fromEntries(Object.entries(options).map((_tct_transform_4 = ([k, v]) => [
                `beam:option:${camel_to_snake(k)}:v1`,
                v,
            ], _tct_transform_4.__closure = () => ({ camel_to_snake }), _tct_transform_4))));
        }
        const client = await this.getClient();
        // Ensure the pipeline (and other metadata) serializes, as the failure
        // in grpc is hard to recover from.
        PrepareJobRequest.toBinary(message);
        const prepareResponse = await client.prepare(message).response;
        // Allow the runner to fetch any artifacts it can't interpret.
        if (prepareResponse.artifactStagingEndpoint) {
            console.debug("Staging artifacts");
            await artifacts.offerArtifacts(new ArtifactStagingServiceClient(new GrpcTransport({
                host: prepareResponse.artifactStagingEndpoint.url,
                channelCredentials: ChannelCredentials.createInsecure(),
            })), prepareResponse.stagingSessionToken, "/");
        }
        // Actually kick off the job.
        console.debug("Running job.");
        const runCall = client.run({
            preparationId: prepareResponse.preparationId,
            retrievalToken: "",
        });
        const { jobId } = await runCall.response;
        // Return a handle the user can use to monitor the job as it's running.
        // If desired, the user can use this handle to await job completion, but
        // this function returns as soon as the job is successfully started, not
        // once the job has completed.
        return new PortableRunnerPipelineResult(this, jobId, completionCallbacks);
    }
}
exports.PortableRunner = PortableRunner;
//# sourceMappingURL=runner.js.map