"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
// TODO(serialization): See if we can avoid this.
function callAssertDeepEqual(a, b) {
    return assert.deepEqual(a, b);
}
var _tct_transform_1, _tct_transform_2;
callAssertDeepEqual.__closure = () => ({ assert });
// TODO: (Naming)
/**
 * A PTransform that will fail the pipeline if the input PCollection does not
 * contain exactly the given elements (in any order).  Useful for writing test,
 * e.g.
 *
 *```js
 * pcoll.apply(assertDeepEqual(1, 2, 3));
 *```
 */
function assertDeepEqual(expected) {
    return beam.withName(`assertDeepEqual(${JSON.stringify(expected).substring(0, 100)})`, (_tct_transform_1 = function assertDeepEqual(pcoll) {
        var _tct_transform_3;
        pcoll.apply(assertContentsSatisfies((_tct_transform_3 = (actual) => {
            var _tct_transform_4, _tct_transform_5;
            const actualArray = [...actual];
            expected.sort((_tct_transform_4 = (a, b) => JSON.stringify(a) < JSON.stringify(b) ? -1 : 1, _tct_transform_4.__closure = () => ({ JSON }), _tct_transform_4));
            actualArray.sort((_tct_transform_5 = (a, b) => JSON.stringify(a) < JSON.stringify(b) ? -1 : 1, _tct_transform_5.__closure = () => ({ JSON }), _tct_transform_5));
            callAssertDeepEqual(actualArray, expected);
        }, _tct_transform_3.__closure = () => ({ expected, JSON, callAssertDeepEqual }), _tct_transform_3)));
    }, _tct_transform_1.__closure = () => ({ assertContentsSatisfies, expected, JSON, callAssertDeepEqual }), _tct_transform_1));
}
assertDeepEqual.__closure = () => ({ beam, JSON, assertContentsSatisfies, callAssertDeepEqual });
/**
 * A PTransform that will fail the pipeline if the given callback fails when
 * called with the input PCollection's elements.
 *
 * Note that the callback must not be sensitive to ordering, as the ordering
 * of the provided elements is not well determined.
 */
function assertContentsSatisfies(check) {
    function expand(pcoll) {
        // We provide some value here to ensure there is at least one element
        // so the DoFn gets invoked.
        const singleton = pcoll
            .root()
            .apply(beam.impulse())
            .map((_) => ({ tag: "expected" }));
        // CoGBK.
        const tagged = pcoll
            .map((e) => ({ tag: "actual", value: e }))
            .apply(beam.windowInto(globalWindows()));
        beam.P([singleton, tagged])
            .apply(beam.flatten())
            .apply(beam.groupBy((e) => 0))
            .map(beam.withName("extractActual", (_tct_transform_2 = (kv) => {
            const actual = kv.value?.filter((o) => o.tag === "actual").map((o) => o.value) ||
                [];
            check(actual);
        }, _tct_transform_2.__closure = () => ({ check }), _tct_transform_2)));
    }
    expand.__closure = () => ({ beam, globalWindows, check });
    return beam.withName(`assertContentsSatisfies(${beam.extractName(check)})`, expand);
}
assertContentsSatisfies.__closure = () => ({ beam, globalWindows });
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertContentsSatisfies = exports.assertDeepEqual = void 0;
/**
 * Various transforms useful for asserting the expected contents of
 * PCollections, primarily for for testing.
 *
 * @packageDocumentation
 */
const _tct_flatten_destructured_imports_1 = __importStar(require("../index"));
var beam = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../transforms/windowings"));
var globalWindows = _tct_flatten_destructured_imports_2.globalWindows;
const _tct_flatten_destructured_imports_3 = __importStar(require("../transforms/internal"));
var internal = _tct_flatten_destructured_imports_3;
const _tct_flatten_destructured_imports_4 = __importStar(require("assert"));
var assert = _tct_flatten_destructured_imports_4;
exports.assertDeepEqual = assertDeepEqual;
exports.assertContentsSatisfies = assertContentsSatisfies;
const _tct_flatten_destructured_imports_5 = __importStar(require("../serialization"));
var requireForSerialization = _tct_flatten_destructured_imports_5.requireForSerialization;
requireForSerialization("apache-beam/testing/assert", exports);
requireForSerialization("apache-beam/testing/assert", {
    callAssertDeepEqual,
});
requireForSerialization("assert");
//# sourceMappingURL=assert.js.map