"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
// TODO: (API) (Types) This class expects PCollections to already have the
// correct Coders. It would be great if we could infer coders, or at least have
// a cleaner way to specify them than using internal.WithCoderInternal.
function rawExternalTransform(urn, payload, serviceProviderOrAddress, options = {}) {
    return new RawExternalTransform(urn, payload, serviceProviderOrAddress, options);
}
rawExternalTransform.__closure = () => ({ RawExternalTransform });
function encodeSchemaPayload(payload, schema = undefined) {
    const encoded = new Writer();
    if (!schema) {
        schema = RowCoder.inferSchemaOfJSON(payload);
    }
    new RowCoder(schema).encode(payload, encoded, null);
    return ExternalConfigurationPayload.toBinary({
        schema: schema,
        payload: encoded.finish(),
    });
}
encodeSchemaPayload.__closure = () => ({ Writer, RowCoder, ExternalConfigurationPayload });
Object.defineProperty(exports, "__esModule", { value: true });
exports.rawExternalTransform = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("@grpc/grpc-js"));
var ChannelCredentials = _tct_flatten_destructured_imports_1.ChannelCredentials;
const _tct_flatten_destructured_imports_2 = __importStar(require("@protobuf-ts/grpc-transport"));
var GrpcTransport = _tct_flatten_destructured_imports_2.GrpcTransport;
const _tct_flatten_destructured_imports_3 = __importStar(require("protobufjs"));
var Writer = _tct_flatten_destructured_imports_3.Writer;
const _tct_flatten_destructured_imports_4 = __importStar(require("../proto/beam_expansion_api"));
var ExpansionRequest = _tct_flatten_destructured_imports_4.ExpansionRequest;
var ExpansionResponse = _tct_flatten_destructured_imports_4.ExpansionResponse;
const _tct_flatten_destructured_imports_5 = __importStar(require("../proto/beam_expansion_api.client"));
var ExpansionServiceClient = _tct_flatten_destructured_imports_5.ExpansionServiceClient;
var IExpansionServiceClient = _tct_flatten_destructured_imports_5.IExpansionServiceClient;
const _tct_flatten_destructured_imports_6 = __importStar(require("../proto/beam_artifact_api.client"));
var ArtifactRetrievalServiceClient = _tct_flatten_destructured_imports_6.ArtifactRetrievalServiceClient;
var IArtifactRetrievalServiceClient = _tct_flatten_destructured_imports_6.IArtifactRetrievalServiceClient;
const _tct_flatten_destructured_imports_7 = __importStar(require("../proto/beam_runner_api"));
var runnerApi = _tct_flatten_destructured_imports_7;
const _tct_flatten_destructured_imports_8 = __importStar(require("../proto/external_transforms"));
var ExternalConfigurationPayload = _tct_flatten_destructured_imports_8.ExternalConfigurationPayload;
const _tct_flatten_destructured_imports_9 = __importStar(require("../proto/schema"));
var Schema = _tct_flatten_destructured_imports_9.Schema;
const _tct_flatten_destructured_imports_10 = __importStar(require("../pvalue"));
var PValue = _tct_flatten_destructured_imports_10.PValue;
var PCollection = _tct_flatten_destructured_imports_10.PCollection;
const _tct_flatten_destructured_imports_11 = __importStar(require("../internal/pipeline"));
var Pipeline = _tct_flatten_destructured_imports_11.Pipeline;
const _tct_flatten_destructured_imports_12 = __importStar(require("../coders/standard_coders"));
var coders = _tct_flatten_destructured_imports_12;
const _tct_flatten_destructured_imports_13 = __importStar(require("./internal"));
var internal = _tct_flatten_destructured_imports_13;
const _tct_flatten_destructured_imports_14 = __importStar(require("./transform"));
var transform = _tct_flatten_destructured_imports_14;
const _tct_flatten_destructured_imports_15 = __importStar(require("../coders/row_coder"));
var RowCoder = _tct_flatten_destructured_imports_15.RowCoder;
const _tct_flatten_destructured_imports_16 = __importStar(require("../coders/coders"));
var Coder = _tct_flatten_destructured_imports_16.Coder;
const _tct_flatten_destructured_imports_17 = __importStar(require("../runners/artifacts"));
var artifacts = _tct_flatten_destructured_imports_17;
const _tct_flatten_destructured_imports_18 = __importStar(require("../utils/service"));
var service = _tct_flatten_destructured_imports_18;
const defaultRawExternalTransformOptions = {
    inferPValueType: true,
    requestedOutputCoders: {},
};
exports.rawExternalTransform = rawExternalTransform;
class RawExternalTransform extends transform.AsyncPTransformClass {
    constructor(urn, payload, serviceProviderOrAddress, options) {
        var _tct_transform_1;
        super("External(" + urn + ")");
        this.urn = urn;
        this.options = { ...defaultRawExternalTransformOptions, ...options };
        if (payload === null || payload === undefined) {
            this.payload = undefined;
        }
        else if (payload instanceof Uint8Array) {
            this.payload = payload;
        }
        else {
            this.payload = encodeSchemaPayload(payload);
        }
        if (typeof serviceProviderOrAddress === "string") {
            this.serviceProvider = (_tct_transform_1 = async () => new service.ExternalService(serviceProviderOrAddress), _tct_transform_1.__closure = () => ({ service, serviceProviderOrAddress }), _tct_transform_1);
        }
        else {
            this.serviceProvider = serviceProviderOrAddress;
        }
    }
    static freshNamespace() {
        return "namespace_" + RawExternalTransform.namespaceCounter++ + "_";
    }
    async expandInternalAsync(input, pipeline, transformProto) {
        const pipelineComponents = pipeline.getProto().components;
        const namespace = RawExternalTransform.freshNamespace();
        const request = ExpansionRequest.create({
            transform: runnerApi.PTransform.create({
                uniqueName: transformProto.uniqueName,
                spec: { urn: this.urn, payload: this.payload },
                inputs: transformProto.inputs,
            }),
            components: {},
            namespace: namespace,
        });
        // Some SDKs are not happy with PCollections created out of thin air.
        const fakeImpulseNamespace = RawExternalTransform.freshNamespace();
        for (const pcId of Object.values(transformProto.inputs)) {
            request.components.pcollections[pcId] =
                pipelineComponents.pcollections[pcId];
            request.components.transforms[fakeImpulseNamespace + pcId] =
                runnerApi.PTransform.create({
                    uniqueName: fakeImpulseNamespace + "_create_" + pcId,
                    spec: { urn: internal.impulse.urn, payload: new Uint8Array() },
                    outputs: { main: pcId },
                });
        }
        for (const [output, coder] of Object.entries(this.options.requestedOutputCoders)) {
            request.outputCoderRequests[output] = pipeline.getCoderId(coder);
        }
        // Copy all the rest, as there may be opaque references.
        Object.assign(request.components.coders, pipelineComponents.coders);
        Object.assign(request.components.windowingStrategies, pipelineComponents.windowingStrategies);
        Object.assign(request.components.environments, pipelineComponents.environments);
        const service = await this.serviceProvider();
        const address = await service.start();
        const client = new ExpansionServiceClient(new GrpcTransport({
            host: address,
            channelCredentials: ChannelCredentials.createInsecure(),
        }));
        try {
            const response = await client.expand(request).response;
            if (response.error) {
                throw new Error(response.error);
            }
            response.components = await this.resolveArtifacts(response.components, address);
            return this.splice(pipeline, transformProto, response, namespace);
        }
        finally {
            await service.stop();
        }
    }
    /**
     * The returned pipeline fragment may have dependencies (referenced in its)
     * environments) that are needed for execution. This function fetches (as
     * required) these artifacts from the expansion service (which may be
     * be transient) and stores them in files such that it may then forward
     * these artifacts to the choice of runner.
     */
    async resolveArtifacts(components, address) {
        var _tct_transform_2;
        // Don't even bother creating a connection if there are no dependencies.
        if (Object.values(components.environments).every((env) => env.dependencies.length === 0)) {
            return components;
        }
        // An expansion service that returns environments with dependencies must
        // aslo vend an artifact retrieval service as that same port.
        const artifactClient = new ArtifactRetrievalServiceClient(new GrpcTransport({
            host: address,
            channelCredentials: ChannelCredentials.createInsecure(),
        }));
        // For each new environment, convert (if needed) all dependencies into
        // a more permanent form.
        for (const env of Object.values(components.environments)) {
            if (env.dependencies.length > 0) {
                env.dependencies = Array.from(await (_tct_transform_2 = async () => {
                    let result = [];
                    for await (const dep of artifacts.resolveArtifacts(artifactClient, env.dependencies)) {
                        result.push(dep);
                    }
                    return result;
                }, _tct_transform_2.__closure = () => ({ artifacts, artifactClient, env }), _tct_transform_2)());
            }
        }
        return components;
    }
    splice(pipeline, transformProto, response, namespace) {
        function copyNamespaceComponents(src, dest) {
            for (const [id, proto] of Object.entries(src)) {
                if (id.startsWith(namespace)) {
                    dest[id] = proto;
                }
            }
        }
        var _tct_transform_3, _tct_transform_4, _tct_transform_5, _tct_transform_6, _tct_transform_7;
        copyNamespaceComponents.__closure = () => ({ Object, namespace });
        function difference(a, b) {
            return [...a].filter((_tct_transform_3 = (x) => !b.has(x), _tct_transform_3.__closure = () => ({ b }), _tct_transform_3));
        }
        // Some SDKs enforce input naming conventions.
        const newTags = difference(new Set(Object.keys(response.transform.inputs)), new Set(Object.keys(transformProto.inputs)));
        if (newTags.length > 1) {
            throw new Error("Ambiguous renaming of tags.");
        }
        else if (newTags.length === 1) {
            const missingTags = difference(new Set(Object.keys(transformProto.inputs)), new Set(Object.keys(response.transform.inputs)));
            transformProto.inputs[newTags[0]] = transformProto.inputs[missingTags[0]];
            delete transformProto.inputs[missingTags[0]];
        }
        // PCollection ids may have changed as well.
        const renamedInputs = Object.fromEntries(Object.keys(response.transform.inputs).map((_tct_transform_4 = (k) => [
            response.transform.inputs[k],
            transformProto.inputs[k],
        ], _tct_transform_4.__closure = () => ({ response, transformProto }), _tct_transform_4)));
        response.transform.inputs = Object.fromEntries(Object.entries(response.transform.inputs).map((_tct_transform_5 = ([k, v]) => [
            k,
            renamedInputs[v],
        ], _tct_transform_5.__closure = () => ({ renamedInputs }), _tct_transform_5)));
        for (const t of Object.values(response.components.transforms)) {
            t.inputs = Object.fromEntries(Object.entries(t.inputs).map((_tct_transform_6 = ([k, v]) => [
                k,
                renamedInputs[v] !== null && renamedInputs[v] !== undefined
                    ? renamedInputs[v]
                    : v,
            ], _tct_transform_6.__closure = () => ({ renamedInputs }), _tct_transform_6)));
        }
        // Copy the proto contents.
        Object.assign(transformProto, response.transform);
        // Now copy everything over.
        const proto = pipeline.getProto();
        const pipelineComponents = proto.components;
        pipeline.getProto().requirements.push(...response.requirements);
        copyNamespaceComponents(response.components.transforms, pipelineComponents.transforms);
        copyNamespaceComponents(response.components.pcollections, pipelineComponents.pcollections);
        copyNamespaceComponents(response.components.coders, pipelineComponents.coders);
        copyNamespaceComponents(response.components.environments, pipelineComponents.environments);
        copyNamespaceComponents(response.components.windowingStrategies, pipelineComponents.windowingStrategies);
        // Ensure we understand the resulting coders.
        // TODO: We could still patch things together if we don't understand the coders,
        // but the errors are harder to follow.  Consider only rejecting coders that
        // actually cross the boundary.
        for (const pcId of Object.values(response.transform.outputs)) {
            const pcProto = pipelineComponents.pcollections[pcId];
            pipeline.context.getCoder(pcProto.coderId);
        }
        // Construct and return the resulting object.
        // TODO: (Typescipt) Can I get the concrete OutputT at runtime?
        // TypeScript types are not available at runtime. If I understand correctly, there is no plan to change that at the moment.
        // See: https://github.com/microsoft/TypeScript/issues/47658
        // See: https://github.com/microsoft/TypeScript/issues/3628
        if (this.options.inferPValueType) {
            const outputKeys = [...Object.keys(response.transform.outputs)];
            if (outputKeys.length === 0) {
                return null;
            }
            else if (outputKeys.length === 1) {
                return new PCollection(pipeline, response.transform.outputs[outputKeys[0]]);
            }
        }
        return Object.fromEntries(Object.entries(response.transform.outputs).map((_tct_transform_7 = ([k, v]) => [
            k,
            new PCollection(pipeline, v),
        ], _tct_transform_7.__closure = () => ({ PCollection, pipeline }), _tct_transform_7)));
    }
}
RawExternalTransform.namespaceCounter = 0;
//# sourceMappingURL=external.js.map