"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function createSideInputInfo(transformProto, spec, operatorContext) {
    const globalWindow = new GlobalWindow();
    const sideInputInfo = new Map();
    for (const [sideInputId, sideInput] of Object.entries(spec.sideInputs)) {
        let windowMappingFn;
        switch (sideInput.windowMappingFn.urn) {
            case urns.GLOBAL_WINDOW_MAPPING_FN_URN:
                windowMappingFn = (_tct_transform_1 = (window) => globalWindow, _tct_transform_1.__closure = () => ({ globalWindow }), _tct_transform_1);
                break;
            case urns.IDENTITY_WINDOW_MAPPING_FN_URN:
                windowMappingFn = (window) => window;
                break;
            default:
                throw new Error("Unsupported window mapping fn: " + sideInput.windowMappingFn.urn);
        }
        const sidePColl = operatorContext.descriptor.pcollections[transformProto.inputs[sideInputId]];
        const windowingStrategy = operatorContext.pipelineContext.getWindowingStrategy(sidePColl.windowingStrategyId);
        sideInputInfo.set(sideInputId, {
            elementCoder: operatorContext.pipelineContext.getCoder(sidePColl.coderId),
            windowCoder: operatorContext.pipelineContext.getCoder(windowingStrategy.windowCoderId),
            windowMappingFn: windowMappingFn,
        });
    }
    return sideInputInfo;
}
var _tct_transform_1;
createSideInputInfo.__closure = () => ({ GlobalWindow, Map, Object, urns, Error });
function createStateKey(transformId, accessPattern, sideInputId, window, windowCoder) {
    const writer = new protobufjs.Writer();
    windowCoder.encode(window, writer, CoderContext.needsDelimiters);
    const encodedWindow = writer.finish();
    switch (accessPattern) {
        case "beam:side_input:iterable:v1":
            return {
                type: {
                    oneofKind: "iterableSideInput",
                    iterableSideInput: {
                        transformId: transformId,
                        sideInputId: sideInputId,
                        window: encodedWindow,
                    },
                },
            };
        default:
            throw new Error("Unimplemented access pattern: " + accessPattern);
    }
}
createStateKey.__closure = () => ({ protobufjs, CoderContext, Error });
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStateKey = exports.createSideInputInfo = exports.ParamProviderImpl = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("protobufjs"));
var protobufjs = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../proto/beam_runner_api"));
var runnerApi = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("../proto/beam_fn_api"));
var fnApi = _tct_flatten_destructured_imports_3;
const _tct_flatten_destructured_imports_4 = __importStar(require("./metrics"));
var MetricsContainer = _tct_flatten_destructured_imports_4.MetricsContainer;
var MetricSpec = _tct_flatten_destructured_imports_4.MetricSpec;
const _tct_flatten_destructured_imports_5 = __importStar(require("./state"));
var StateProvider = _tct_flatten_destructured_imports_5.StateProvider;
const _tct_flatten_destructured_imports_6 = __importStar(require("../internal/urns"));
var urns = _tct_flatten_destructured_imports_6;
const _tct_flatten_destructured_imports_7 = __importStar(require("../coders/coders"));
var Coder = _tct_flatten_destructured_imports_7.Coder;
var CoderContext = _tct_flatten_destructured_imports_7.Context;
const _tct_flatten_destructured_imports_8 = __importStar(require("../coders/required_coders"));
var GlobalWindowCoder = _tct_flatten_destructured_imports_8.GlobalWindowCoder;
const _tct_flatten_destructured_imports_9 = __importStar(require("../values"));
var Window = _tct_flatten_destructured_imports_9.Window;
var Instant = _tct_flatten_destructured_imports_9.Instant;
var PaneInfo = _tct_flatten_destructured_imports_9.PaneInfo;
var GlobalWindow = _tct_flatten_destructured_imports_9.GlobalWindow;
var WindowedValue = _tct_flatten_destructured_imports_9.WindowedValue;
const _tct_flatten_destructured_imports_10 = __importStar(require("../transforms/pardo"));
var DoFn = _tct_flatten_destructured_imports_10.DoFn;
var ParDoParam = _tct_flatten_destructured_imports_10.ParDoParam;
var ParamProvider = _tct_flatten_destructured_imports_10.ParamProvider;
var SideInputParam = _tct_flatten_destructured_imports_10.SideInputParam;
const _tct_flatten_destructured_imports_11 = __importStar(require("./operators"));
var operators = _tct_flatten_destructured_imports_11;
/**
 * @fileoverview This is where we handle the magic of populating the context
 * properties for Maps and ParDos. It is rather javascript-specific, both
 * in the way the contexts are manipulated and in the finagling we have to
 * because there is no blocking way to interact with the runner to look up
 * things like side inputs.
 */
class ParamProviderImpl {
    constructor(transformId, sideInputInfo, getStateProvider, metricsContainer) {
        this.transformId = transformId;
        this.sideInputInfo = sideInputInfo;
        this.getStateProvider = getStateProvider;
        this.metricsContainer = metricsContainer;
        this.wvalue = undefined;
        this.sideInputValues = new Map();
    }
    // Avoid modifying the original object, as that could have surprising results
    // if they are widely shared.
    augmentContext(context) {
        this.prefetchCallbacks = [];
        if (typeof context !== "object") {
            return context;
        }
        const result = Object.create(context);
        for (const [name, value] of Object.entries(context)) {
            // Is this the best way to check post serialization?
            if (typeof value === "object" &&
                value !== null &&
                value["parDoParamName"] !== undefined) {
                result[name] = Object.create(value);
                result[name].provider = this;
                if (value.parDoParamName === "sideInput") {
                    this.prefetchCallbacks.push(this.prefetchSideInput(value));
                }
            }
        }
        return result;
    }
    prefetchSideInput(param) {
        var _tct_transform_2, _tct_transform_3;
        const this_ = this;
        const stateProvider = this.getStateProvider();
        const { windowCoder, elementCoder, windowMappingFn } = this.sideInputInfo.get(param.sideInputId);
        const isGlobal = windowCoder instanceof GlobalWindowCoder;
        const decode = (_tct_transform_2 = (encodedElements) => {
            var _tct_transform_4;
            return param.accessor.toValue((_tct_transform_4 = function* () {
                const reader = new protobufjs.Reader(encodedElements);
                while (reader.pos < reader.len) {
                    yield elementCoder.decode(reader, CoderContext.needsDelimiters);
                }
            }, _tct_transform_4.__closure = () => ({ protobufjs, encodedElements, elementCoder, CoderContext }), _tct_transform_4)());
        }, _tct_transform_2.__closure = () => ({ param, protobufjs, elementCoder, CoderContext }), _tct_transform_2);
        return _tct_transform_3 = (window) => {
            var _tct_transform_5;
            if (isGlobal && this_.sideInputValues.has(param.sideInputId)) {
                return operators.NonPromise;
            }
            const stateKey = createStateKey(this_.transformId, param.accessor.accessPattern, param.sideInputId, window, windowCoder);
            const lookupResult = stateProvider.getState(stateKey, decode);
            if (lookupResult.type === "value") {
                this_.sideInputValues.set(param.sideInputId, lookupResult.value);
                return operators.NonPromise;
            }
            else {
                return lookupResult.promise.then((_tct_transform_5 = (value) => {
                    this_.sideInputValues.set(param.sideInputId, value);
                }, _tct_transform_5.__closure = () => ({ this_, param }), _tct_transform_5));
            }
        }, _tct_transform_3.__closure = () => ({ isGlobal, this_, param, operators, createStateKey, windowCoder, stateProvider, decode }), _tct_transform_3;
    }
    setCurrentValue(wvalue) {
        this.wvalue = wvalue;
        if (wvalue === null || wvalue === undefined) {
            return operators.NonPromise;
        }
        // We have to prefetch all the side inputs.
        // TODO: (API) Let the user's process() await them.
        if (this.prefetchCallbacks.length === 0) {
            return operators.NonPromise;
        }
        else {
            const result = new operators.ProcessResultBuilder();
            for (const cb of this.prefetchCallbacks) {
                result.add(cb(wvalue.windows[0]));
            }
            return result.build();
        }
    }
    lookup(param) {
        if (this.wvalue === null || this.wvalue === undefined) {
            throw new Error(param.parDoParamName + " not defined outside of a process() call.");
        }
        switch (param.parDoParamName) {
            case "window":
                // If we're here and there was more than one window, we have exploded.
                return this.wvalue.windows[0];
            case "timestamp":
                return this.wvalue.timestamp;
            case "paneinfo":
                return this.wvalue.pane;
            case "sideInput":
                return this.sideInputValues.get(param.sideInputId);
            default:
                throw new Error("Unknown context parameter: " + param.parDoParamName);
        }
    }
    update(param, value) {
        switch (param.parDoParamName) {
            case "metric":
                this.metricsContainer
                    .getMetric(this.transformId, undefined, param)
                    .update(value);
                break;
            default:
                throw new Error("Unknown context parameter: " + param.parDoParamName);
        }
    }
}
exports.ParamProviderImpl = ParamProviderImpl;
exports.createSideInputInfo = createSideInputInfo;
exports.createStateKey = createStateKey;
//# sourceMappingURL=pardo_context.js.map