"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function needs_ulr_it(name, fn) {
    return (process.env.BEAM_SERVICE_OVERRIDES ? it : it.skip)(name + " @ulr", fn);
}
var _tct_transform_1, _tct_transform_2, _tct_transform_3;
needs_ulr_it.__closure = () => ({ process, it });
Object.defineProperty(exports, "__esModule", { value: true });
const long_1 = __importStar(require("long")), _tct_flatten_destructured_imports_1 = long_1;
var Long = _tct_flatten_destructured_imports_1.default;
const _tct_flatten_destructured_imports_2 = __importStar(require("../../src/apache_beam"));
var beam = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("../../src/apache_beam"));
var PCollection = _tct_flatten_destructured_imports_3.PCollection;
const _tct_flatten_destructured_imports_4 = __importStar(require("../../src/apache_beam/coders/standard_coders"));
var VarIntCoder = _tct_flatten_destructured_imports_4.VarIntCoder;
var StrUtf8Coder = _tct_flatten_destructured_imports_4.StrUtf8Coder;
const _tct_flatten_destructured_imports_5 = __importStar(require("../../src/apache_beam/coders/required_coders"));
var KVCoder = _tct_flatten_destructured_imports_5.KVCoder;
const _tct_flatten_destructured_imports_6 = __importStar(require("../../src/apache_beam/transforms/internal"));
var withCoderInternal = _tct_flatten_destructured_imports_6.withCoderInternal;
const _tct_flatten_destructured_imports_7 = __importStar(require("../../src/apache_beam/transforms/combiners"));
var combiners = _tct_flatten_destructured_imports_7;
const _tct_flatten_destructured_imports_8 = __importStar(require("../../src/apache_beam/transforms/pardo"));
var pardo = _tct_flatten_destructured_imports_8;
const _tct_flatten_destructured_imports_9 = __importStar(require("../../src/apache_beam/transforms/windowings"));
var windowings = _tct_flatten_destructured_imports_9;
const _tct_flatten_destructured_imports_10 = __importStar(require("../../src/apache_beam/coders/row_coder"));
var row_coder = _tct_flatten_destructured_imports_10;
const _tct_flatten_destructured_imports_11 = __importStar(require("../../src/apache_beam/serialization"));
var requireForSerialization = _tct_flatten_destructured_imports_11.requireForSerialization;
const _tct_flatten_destructured_imports_12 = __importStar(require("../../src/apache_beam/transforms/python"));
var pythonTransform = _tct_flatten_destructured_imports_12.pythonTransform;
var pythonCallable = _tct_flatten_destructured_imports_12.pythonCallable;
const _tct_flatten_destructured_imports_13 = __importStar(require("../../src/apache_beam/utils/service"));
var service = _tct_flatten_destructured_imports_13;
const _tct_flatten_destructured_imports_14 = __importStar(require("../../src/apache_beam/runners/runner"));
var loopbackRunner = _tct_flatten_destructured_imports_14.loopbackRunner;
const _tct_flatten_destructured_imports_15 = __importStar(require("../../src/apache_beam/testing/assert"));
var assertDeepEqual = _tct_flatten_destructured_imports_15.assertDeepEqual;
let subprocessCache;
before((_tct_transform_1 = async function () {
    var _tct_transform_4;
    this.timeout(30000);
    subprocessCache = service.SubprocessService.createCache();
    if (process.env.BEAM_SERVICE_OVERRIDES) {
        // Start it up here so we don't timeout any individual test.
        await loopbackRunner().run((_tct_transform_4 = function pipeline(root) {
            root.apply(beam.impulse());
        }, _tct_transform_4.__closure = () => ({ beam }), _tct_transform_4));
    }
}, _tct_transform_1.__closure = () => ({ subprocessCache, service, process, loopbackRunner, beam }), _tct_transform_1));
after((_tct_transform_2 = () => subprocessCache.stopAll(), _tct_transform_2.__closure = () => ({ subprocessCache }), _tct_transform_2));
describe("Programming Guide Tested Samples", (_tct_transform_3 = function () {
    var _tct_transform_5, _tct_transform_6, _tct_transform_7, _tct_transform_8, _tct_transform_9, _tct_transform_10, _tct_transform_11;
    describe("Pipelines", (_tct_transform_5 = function () {
        var _tct_transform_12, _tct_transform_13, _tct_transform_14;
        it("pipelines_constructing_creating", (_tct_transform_12 = async function () {
            // [START pipelines_constructing_creating]
            await beam.createRunner().run(function pipeline(root) {
                // Use root to build a pipeline.
            });
            // [END pipelines_constructing_creating]
        }, _tct_transform_12.__closure = () => ({ beam }), _tct_transform_12));
        it("pipeline_options", (_tct_transform_13 = async function () {
            const yargs = { argv: {} };
            // [START pipeline_options]
            const pipeline_options = {
                runner: "default",
                project: "my_project",
            };
            const runner = beam.createRunner(pipeline_options);
            const runnerFromCommandLineOptions = beam.createRunner(yargs.argv);
            // [END pipeline_options]
        }, _tct_transform_13.__closure = () => ({ beam }), _tct_transform_13));
        it("pipeline_options_define_custom", async function () {
            const yargs = { argv: {} };
            // [START pipeline_options_define_custom]
            const options = yargs.argv; // Or an alternative command-line parsing library.
            // Use options.input and options.output during pipeline construction.
            // [END pipeline_options_define_custom]
        });
        it("pipelines_constructing_reading", (_tct_transform_14 = async function () {
            // [START pipelines_constructing_reading]
            async function pipeline(root) {
                // Note that textio.ReadFromText is an AsyncPTransform.
                const pcoll = await root.applyAsync(textio.ReadFromText("path/to/text_pattern"));
            }
            pipeline.__closure = () => ({ textio });
            const textio = require("../../src/apache_beam/io/textio");
            // [END pipelines_constructing_reading]
        }, _tct_transform_14.__closure = () => ({ textio, require }), _tct_transform_14));
    }, _tct_transform_5.__closure = () => ({ it, beam, textio, require }), _tct_transform_5));
    describe("PCollections", (_tct_transform_6 = function () {
        var _tct_transform_15;
        it("create_pcollection", (_tct_transform_15 = async function () {
            // [START create_pcollection]
            function pipeline(root) {
                const pcoll = root.apply(beam.create([
                    "To be, or not to be: that is the question: ",
                    "Whether 'tis nobler in the mind to suffer ",
                    "The slings and arrows of outrageous fortune, ",
                    "Or to take arms against a sea of troubles, ",
                ]));
            }
            pipeline.__closure = () => ({ beam });
            // [END create_pcollection]
            await beam.createRunner().run(pipeline);
        }, _tct_transform_15.__closure = () => ({ beam }), _tct_transform_15));
    }, _tct_transform_6.__closure = () => ({ it, beam }), _tct_transform_6));
    describe("Transforms", (_tct_transform_7 = function () {
        var _tct_transform_16, _tct_transform_17, _tct_transform_18, _tct_transform_19, _tct_transform_20, _tct_transform_21, _tct_transform_22, _tct_transform_23, _tct_transform_24, _tct_transform_25, _tct_transform_26, _tct_transform_27, _tct_transform_28, _tct_transform_29, _tct_transform_30;
        it("model_pardo", (_tct_transform_16 = async function () {
            // [START model_pardo_pardo]
            function computeWordLengthFn() {
                return {
                    process: function* (element) {
                        yield element.length;
                    },
                };
            }
            var _tct_transform_31;
            // [END model_pardo_pardo]
            await beam.createRunner().run((_tct_transform_31 = (root) => {
                const words = root.apply(beam.create(["a", "bb", "cccc"]));
                // [START model_pardo_apply]
                const result = words.apply(beam.parDo(computeWordLengthFn()));
                // [END model_pardo_apply]
                result.apply(assertDeepEqual([1, 2, 4]));
            }, _tct_transform_31.__closure = () => ({ beam, computeWordLengthFn, assertDeepEqual }), _tct_transform_31));
        }, _tct_transform_16.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_16));
        it("model_pardo_using_flatmap", (_tct_transform_17 = async function () {
            var _tct_transform_32;
            await beam.createRunner().run((_tct_transform_32 = (root) => {
                const words = root.apply(beam.create(["a", "bb", "cccc"]));
                // [START model_pardo_using_flatmap]
                const result = words.flatMap((word) => [word.length]);
                // [END model_pardo_using_flatmap]
                result.apply(assertDeepEqual([1, 2, 4]));
            }, _tct_transform_32.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_32));
        }, _tct_transform_17.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_17));
        it("model_pardo_using_map", (_tct_transform_18 = async function () {
            var _tct_transform_33;
            await beam.createRunner().run((_tct_transform_33 = (root) => {
                const words = root.apply(beam.create(["a", "bb", "cccc"]));
                // [START model_pardo_using_map]
                const result = words.map((word) => word.length);
                // [END model_pardo_using_map]
                result.apply(assertDeepEqual([1, 2, 4]));
            }, _tct_transform_33.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_33));
        }, _tct_transform_18.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_18));
        it("groupby", (_tct_transform_19 = async function () {
            var _tct_transform_34;
            await beam.createRunner().run((_tct_transform_34 = (root) => {
                function sortValues({ key, value }) {
                    return { key, value: value.sort() };
                }
                const cats = [
                    { word: "cat", score: 1 },
                    { word: "cat", score: 5 },
                ];
                const dogs = [{ word: "dog", score: 5 }];
                const scores = root.apply(beam.create(cats.concat(dogs)));
                // [START groupby]
                // This will produce a PCollection with elements like
                //   {key: "cat", value: [{ word: "cat", score: 1 },
                //                        { word: "cat", score: 5 }, ...]}
                //   {key: "dog", value: [{ word: "dog", score: 5 }, ...]}
                const grouped_by_word = scores.apply(beam.groupBy("word"));
                // This will produce a PCollection with elements like
                //   {key: 3, value: [{ word: "cat", score: 1 },
                //                    { word: "dog", score: 5 },
                //                    { word: "cat", score: 5 }, ...]}
                const by_word_length = scores.apply(beam.groupBy((x) => x.word.length));
                // [END groupby]
                // XXX Should it be {key, values} rather than {key, value}?
                grouped_by_word //
                    .map(sortValues)
                    .apply(assertDeepEqual([
                    { key: "cat", value: cats },
                    { key: "dog", value: dogs },
                ]));
                by_word_length
                    .map(beam.withName("sortLenValues", sortValues))
                    .apply(assertDeepEqual([{ key: 3, value: cats.concat(dogs).sort() }]));
            }, _tct_transform_34.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_34));
        }, _tct_transform_19.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_19));
        it("cogroupbykey", (_tct_transform_20 = async function () {
            var _tct_transform_35;
            await beam.createRunner().run((_tct_transform_35 = (root) => {
                // [START cogroupbykey_inputs]
                const emails_list = [
                    { name: "amy", email: "amy@example.com" },
                    { name: "carl", email: "carl@example.com" },
                    { name: "julia", email: "julia@example.com" },
                    { name: "carl", email: "carl@email.com" },
                ];
                const phones_list = [
                    { name: "amy", phone: "111-222-3333" },
                    { name: "james", phone: "222-333-4444" },
                    { name: "amy", phone: "333-444-5555" },
                    { name: "carl", phone: "444-555-6666" },
                ];
                const emails = root.apply(beam.withName("createEmails", beam.create(emails_list)));
                const phones = root.apply(beam.withName("createPhones", beam.create(phones_list)));
                // [END cogroupbykey_inputs]
                // [START cogroupbykey_raw_outputs]
                const results = [
                    {
                        name: "amy",
                        values: {
                            emails: [{ name: "amy", email: "amy@example.com" }],
                            phones: [
                                { name: "amy", phone: "111-222-3333" },
                                { name: "amy", phone: "333-444-5555" },
                            ],
                        },
                    },
                    {
                        name: "carl",
                        values: {
                            emails: [
                                { name: "carl", email: "carl@example.com" },
                                { name: "carl", email: "carl@email.com" },
                            ],
                            phones: [{ name: "carl", phone: "444-555-6666" }],
                        },
                    },
                    {
                        name: "james",
                        values: {
                            emails: [],
                            phones: [{ name: "james", phone: "222-333-4444" }],
                        },
                    },
                    {
                        name: "julia",
                        values: {
                            emails: [{ name: "julia", email: "julia@example.com" }],
                            phones: [],
                        },
                    },
                ];
                // [END cogroupbykey_raw_outputs]
                // [START cogroupbykey]
                const formatted_results_pcoll = beam.P({ emails, phones })
                    .apply(beam.coGroupBy("name"))
                    .map(function formatResults({ key, values }) {
                    const emails = values.emails.map((x) => x.email).sort();
                    const phones = values.phones.map((x) => x.phone).sort();
                    return `${key}; [${emails}]; [${phones}]`;
                });
                // [END cogroupbykey]
                // [START cogroupbykey_formatted_outputs]
                const formatted_results = [
                    "amy; [amy@example.com]; [111-222-3333,333-444-5555]",
                    "carl; [carl@email.com,carl@example.com]; [444-555-6666]",
                    "james; []; [222-333-4444]",
                    "julia; [julia@example.com]; []",
                ];
                // [END cogroupbykey_formatted_outputs]
                formatted_results_pcoll.apply(assertDeepEqual(formatted_results));
            }, _tct_transform_35.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_35));
        }, _tct_transform_20.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_20));
        it("combine_simple_sum", (_tct_transform_21 = async function () {
            var _tct_transform_36;
            // prettier-ignore
            await beam.createRunner().run((_tct_transform_36 = (root) => {
                // [START combine_simple_sum]
                const pcoll = root.apply(beam.create([1, 10, 100, 1000]));
                const result = pcoll.apply(beam.groupGlobally()
                    .combining((c) => c, (x, y) => x + y, "sum")
                    .combining((c) => c, (x, y) => x * y, "product"));
                const expected = { sum: 1111, product: 1000000 };
                // [END combine_simple_sum]
                result.apply(assertDeepEqual([expected]));
            }, _tct_transform_36.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_36));
        }, _tct_transform_21.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_21));
        it("combine_custom_average", (_tct_transform_22 = async function () {
            var _tct_transform_37;
            await beam.createRunner().run((_tct_transform_37 = (root) => {
                // [START combine_custom_average]
                const meanCombineFn = {
                    createAccumulator: () => [0, 0],
                    addInput: ([sum, count], i) => [
                        sum + i,
                        count + 1,
                    ],
                    mergeAccumulators: (accumulators) => accumulators.reduce(([sum0, count0], [sum1, count1]) => [
                        sum0 + sum1,
                        count0 + count1,
                    ]),
                    extractOutput: ([sum, count]) => sum / count,
                };
                // [END combine_custom_average]
                // [START combine_global_average]
                const pcoll = root.apply(beam.create([4, 5, 6]));
                const result = pcoll.apply(beam.groupGlobally().combining((c) => c, meanCombineFn, "mean"));
                // [END combine_global_average]
                result.apply(assertDeepEqual([{ mean: 5 }]));
            }, _tct_transform_37.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_37));
        }, _tct_transform_22.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_22));
        it("combine_globally", (_tct_transform_23 = async function () {
            var _tct_transform_38;
            await beam.createRunner().run((_tct_transform_38 = (root) => {
                // [START combine_globally]
                const pcoll = root.apply(beam.create([
                    { player: "alice", accuracy: 1.0 },
                    { player: "bob", accuracy: 0.99 },
                    { player: "eve", accuracy: 0.5 },
                    { player: "eve", accuracy: 0.25 },
                ]));
                const result = pcoll.apply(beam.groupGlobally()
                    .combining("accuracy", combiners.mean, "mean")
                    .combining("accuracy", combiners.max, "max"));
                const expected = [{ max: 1.0, mean: 0.685 }];
                // [END combine_globally]
                result.apply(assertDeepEqual(expected));
            }, _tct_transform_38.__closure = () => ({ beam, combiners, assertDeepEqual }), _tct_transform_38));
        }, _tct_transform_23.__closure = () => ({ beam, combiners, assertDeepEqual }), _tct_transform_23));
        it("combine_per_key", (_tct_transform_24 = async function () {
            var _tct_transform_39;
            await beam.createRunner().run((_tct_transform_39 = (root) => {
                // [START combine_per_key]
                const pcoll = root.apply(beam.create([
                    { player: "alice", accuracy: 1.0 },
                    { player: "bob", accuracy: 0.99 },
                    { player: "eve", accuracy: 0.5 },
                    { player: "eve", accuracy: 0.25 },
                ]));
                const result = pcoll.apply(beam.groupBy("player")
                    .combining("accuracy", combiners.mean, "mean")
                    .combining("accuracy", combiners.max, "max"));
                const expected = [
                    { player: "alice", mean: 1.0, max: 1.0 },
                    { player: "bob", mean: 0.99, max: 0.99 },
                    { player: "eve", mean: 0.375, max: 0.5 },
                ];
                // [END combine_per_key]
                result.apply(assertDeepEqual(expected));
            }, _tct_transform_39.__closure = () => ({ beam, combiners, assertDeepEqual }), _tct_transform_39));
        }, _tct_transform_24.__closure = () => ({ beam, combiners, assertDeepEqual }), _tct_transform_24));
        it("model_multiple_pcollections_flatten", (_tct_transform_25 = async function () {
            var _tct_transform_40;
            await beam.createRunner().run((_tct_transform_40 = (root) => {
                // [START model_multiple_pcollections_flatten]
                const fib = root.apply(beam.withName("createFib", beam.create([1, 1, 2, 3, 5, 8])));
                const pow = root.apply(beam.withName("createPow", beam.create([1, 2, 4, 8, 16, 32])));
                const result = beam.P([fib, pow]).apply(beam.flatten());
                // [END model_multiple_pcollections_flatten]
                result.apply(assertDeepEqual([1, 1, 1, 2, 2, 3, 4, 5, 8, 8, 16, 32]));
            }, _tct_transform_40.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_40));
        }, _tct_transform_25.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_25));
        it("model_multiple_pcollections_partition", (_tct_transform_26 = async function () {
            var _tct_transform_41;
            await beam.createRunner().run((_tct_transform_41 = (root) => {
                function getPercentile(s) {
                    return s;
                }
                var _tct_transform_42;
                const students = root.apply(beam.create([1, 5, 50, 98, 99]));
                // [START model_multiple_pcollections_partition]
                const deciles = students.apply(beam.partition((_tct_transform_42 = (student, numPartitions) => Math.floor((getPercentile(student) / 100) * numPartitions), _tct_transform_42.__closure = () => ({ Math, getPercentile }), _tct_transform_42), 10));
                const topDecile = deciles[9];
                // [END model_multiple_pcollections_partition]
                topDecile.apply(assertDeepEqual([98, 99]));
            }, _tct_transform_41.__closure = () => ({ beam, Math, assertDeepEqual }), _tct_transform_41));
        }, _tct_transform_26.__closure = () => ({ beam, Math, assertDeepEqual }), _tct_transform_26));
        it("model_pardo_side_input", (_tct_transform_27 = async function () {
            var _tct_transform_43;
            await beam.createRunner().run((_tct_transform_43 = (root) => {
                const words = root.apply(beam.create(["a", "bb", "cccc"]));
                // [START model_pardo_side_input]
                // meanLengthPColl will contain a single number whose value is the
                // average length of the words
                const meanLengthPColl = words
                    .apply(beam.groupGlobally()
                    .combining((word) => word.length, combiners.mean, "mean"))
                    .map(({ mean }) => mean);
                // Now we use this as a side input to yield only words that are
                // smaller than average.
                const smallWords = words.flatMap(
                // This is the function, taking context as a second argument.
                function* keepSmall(word, context) {
                    if (word.length < context.meanLength.lookup()) {
                        yield word;
                    }
                }, 
                // This is the context that will be passed as a second argument.
                { meanLength: pardo.singletonSideInput(meanLengthPColl) });
                // [END model_pardo_side_input]
                smallWords.apply(assertDeepEqual(["a", "bb"]));
            }, _tct_transform_43.__closure = () => ({ beam, combiners, pardo, assertDeepEqual }), _tct_transform_43));
        }, _tct_transform_27.__closure = () => ({ beam, combiners, pardo, assertDeepEqual }), _tct_transform_27));
        it("model_multiple_output", (_tct_transform_28 = async function () {
            var _tct_transform_44;
            await beam.createRunner().run((_tct_transform_44 = (root) => {
                function isMarkedWord(word) {
                    return word.includes("x");
                }
                var _tct_transform_45;
                const words = root.apply(beam.create(["a", "bb", "cccccc", "xx"]));
                // [START model_multiple_output_dofn]
                const to_split = words.flatMap((_tct_transform_45 = function* (word) {
                    if (word.length < 5) {
                        yield { below: word };
                    }
                    else {
                        yield { above: word };
                    }
                    if (isMarkedWord(word)) {
                        yield { marked: word };
                    }
                }, _tct_transform_45.__closure = () => ({ isMarkedWord }), _tct_transform_45));
                // [END model_multiple_output_dofn]
                // [START model_multiple_output]
                const { below, above, marked } = to_split.apply(beam.split(["below", "above", "marked"]));
                // [END model_multiple_output]
                below.apply(assertDeepEqual(["a", "bb", "xx"]));
                above.apply(assertDeepEqual(["cccccc"]));
                marked.apply(assertDeepEqual(["xx"]));
            }, _tct_transform_44.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_44));
        }, _tct_transform_28.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_28));
        it("other_params", (_tct_transform_29 = async function () {
            var _tct_transform_46;
            await beam.createRunner().run((_tct_transform_46 = (root) => {
                // [START timestamp_param]
                function processFn(element, context) {
                    return context.timestamp.lookup();
                }
                function processWithWindow(element, context) { }
                function processWithPaneInfo(element, context) { }
                const pcoll = root.apply(beam.create(["a", "b", "c"]));
                {
                    pcoll.map(processFn, { timestamp: pardo.timestampParam() });
                    // [END timestamp_param]
                }
                {
                    // [START window_param]
                    pcoll.map(processWithWindow, { timestamp: pardo.windowParam() });
                    // [END window_param]
                    // [START pane_info_param]
                    pcoll.map(processWithPaneInfo, { timestamp: pardo.paneInfoParam() });
                    // [END pane_info_param]
                }
            }, _tct_transform_46.__closure = () => ({ beam, pardo }), _tct_transform_46));
        }, _tct_transform_29.__closure = () => ({ beam, pardo }), _tct_transform_29));
        it("countwords_composite", (_tct_transform_30 = async function () {
            var _tct_transform_47;
            await beam.createRunner().run((_tct_transform_47 = (root) => {
                // [START countwords_composite]
                function countWords(lines) {
                    return lines //
                        .map((s) => s.toLowerCase())
                        .flatMap(function* splitWords(line) {
                        yield* line.split(/[^a-z]+/);
                    })
                        .apply(beam.countPerElement());
                }
                countWords.__closure = () => ({ beam });
                const lines = root.apply(beam.create(["a b", "b c c c"]));
                const counted = lines.apply(countWords);
                // [END countwords_composite]
                counted.apply(assertDeepEqual([
                    { element: "a", count: 1 },
                    { element: "b", count: 2 },
                    { element: "c", count: 3 },
                ]));
            }, _tct_transform_47.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_47));
        }, _tct_transform_30.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_30));
    }, _tct_transform_7.__closure = () => ({ it, beam, assertDeepEqual, combiners, Math, pardo }), _tct_transform_7));
    describe("Coders", (_tct_transform_8 = function () {
        var _tct_transform_48;
        it("with_row_coder", (_tct_transform_48 = async function () {
            var _tct_transform_49;
            await beam.createRunner().run((_tct_transform_49 = (root) => {
                const elements = [
                    { intFieldName: 1, stringFieldName: "foo" },
                    { intFieldName: 2, stringFieldName: "bar" },
                ];
                const pcoll = root.apply(beam.create(elements));
                // [START with_row_coder]
                const result = pcoll.apply(beam.withRowCoder({ intFieldName: 0, stringFieldName: "" }));
                // [END with_row_coder]
                result.apply(assertDeepEqual(elements));
            }, _tct_transform_49.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_49));
        }, _tct_transform_48.__closure = () => ({ beam, assertDeepEqual }), _tct_transform_48));
    }, _tct_transform_8.__closure = () => ({ it, beam, assertDeepEqual }), _tct_transform_8));
    describe("Windowing", (_tct_transform_9 = function () {
        var _tct_transform_50, _tct_transform_51, _tct_transform_52, _tct_transform_53;
        it("fixed_windows", (_tct_transform_50 = async function () {
            var _tct_transform_54;
            await beam.createRunner().run((_tct_transform_54 = async (root) => {
                var _tct_transform_55;
                const pcoll = root
                    .apply(beam.create([1, 2, 3, 4, 5, 60, 61, 62]))
                    .apply(beam.assignTimestamps((_tct_transform_55 = (t) => Long.fromValue(t * 1000), _tct_transform_55.__closure = () => ({ Long }), _tct_transform_55)));
                // [START setting_fixed_windows]
                pcoll
                    .apply(beam.windowInto(windowings.fixedWindows(60)))
                    // [END setting_fixed_windows]
                    .apply(beam.groupBy((e) => ""))
                    .apply(assertDeepEqual([
                    { key: "", value: [1, 2, 3, 4, 5] },
                    { key: "", value: [60, 61, 62] },
                ]));
            }, _tct_transform_54.__closure = () => ({ beam, Long, windowings, assertDeepEqual }), _tct_transform_54));
        }, _tct_transform_50.__closure = () => ({ beam, Long, windowings, assertDeepEqual }), _tct_transform_50));
        it("sliding_windows", (_tct_transform_51 = async function () {
            var _tct_transform_56;
            await beam.createRunner().run((_tct_transform_56 = async (root) => {
                var _tct_transform_57;
                const pcoll = root
                    .apply(beam.create([1, 2, 3, 4, 5, 12]))
                    .apply(beam.assignTimestamps((_tct_transform_57 = (t) => Long.fromValue(t * 1000), _tct_transform_57.__closure = () => ({ Long }), _tct_transform_57)));
                // [START setting_sliding_windows]
                pcoll
                    .apply(beam.windowInto(windowings.slidingWindows(30, 5)))
                    // [END setting_sliding_windows]
                    .apply(beam.groupBy((e) => ""))
                    .apply(assertDeepEqual([
                    { key: "", value: [1, 2, 3, 4, 5, 12] },
                    { key: "", value: [1, 2, 3, 4, 5, 12] },
                    { key: "", value: [1, 2, 3, 4, 5, 12] },
                    { key: "", value: [1, 2, 3, 4, 5, 12] },
                    { key: "", value: [1, 2, 3, 4, 5] },
                    { key: "", value: [1, 2, 3, 4] },
                    { key: "", value: [5, 12] },
                    { key: "", value: [12] },
                ]));
            }, _tct_transform_56.__closure = () => ({ beam, Long, windowings, assertDeepEqual }), _tct_transform_56));
        }, _tct_transform_51.__closure = () => ({ beam, Long, windowings, assertDeepEqual }), _tct_transform_51));
        needs_ulr_it("session_windows", (_tct_transform_52 = async function () {
            var _tct_transform_58;
            await beam.createRunner().run((_tct_transform_58 = async (root) => {
                var _tct_transform_59;
                const pcoll = root
                    .apply(beam.create([1, 2, 600, 1800, 1900]))
                    .apply(beam.assignTimestamps((_tct_transform_59 = (t) => Long.fromValue(t * 1000), _tct_transform_59.__closure = () => ({ Long }), _tct_transform_59)));
                // [START setting_session_windows]
                pcoll
                    .apply(beam.windowInto(windowings.sessions(10 * 60)))
                    // [END setting_session_windows]
                    .apply(beam.groupBy((e) => ""))
                    .apply(assertDeepEqual([
                    { key: "", value: [1, 2, 600] },
                    { key: "", value: [1800, 1900] },
                ]));
            }, _tct_transform_58.__closure = () => ({ beam, Long, windowings, assertDeepEqual }), _tct_transform_58));
        }, _tct_transform_52.__closure = () => ({ beam, Long, windowings, assertDeepEqual }), _tct_transform_52)).timeout(10000);
        it("global_windows", (_tct_transform_53 = async function () {
            var _tct_transform_60;
            await beam.createRunner().run((_tct_transform_60 = async (root) => {
                var _tct_transform_61;
                const pcoll = root
                    .apply(beam.create([1, 2, 3, 4, 5, 60, 61, 62]))
                    .apply(beam.assignTimestamps((_tct_transform_61 = (t) => Long.fromValue(t * 1000), _tct_transform_61.__closure = () => ({ Long }), _tct_transform_61)))
                    // So setting global windows is non-trivial.
                    .apply(beam.windowInto(windowings.fixedWindows(60)));
                // [START setting_global_window]
                pcoll
                    .apply(beam.windowInto(windowings.globalWindows()))
                    // [END setting_global_window]
                    .apply(beam.groupBy((e) => ""))
                    .apply(assertDeepEqual([{ key: "", value: [1, 2, 3, 4, 5, 60, 61, 62] }]));
            }, _tct_transform_60.__closure = () => ({ beam, Long, windowings, assertDeepEqual }), _tct_transform_60));
        }, _tct_transform_53.__closure = () => ({ beam, Long, windowings, assertDeepEqual }), _tct_transform_53));
    }, _tct_transform_9.__closure = () => ({ it, beam, Long, windowings, assertDeepEqual, needs_ulr_it }), _tct_transform_9));
    describe("Schemas and Coders", (_tct_transform_10 = function () {
        var _tct_transform_62, _tct_transform_63;
        it("schema_def", (_tct_transform_62 = async function () {
            var _tct_transform_64;
            await beam.createRunner().run((_tct_transform_64 = async (root) => {
                // [START schema_def]
                const pcoll = root
                    .apply(beam.create([
                    { intField: 1, stringField: "a" },
                    { intField: 2, stringField: "b" },
                ]))
                    // Let beam know the type of the elements by providing an exemplar.
                    .apply(beam.withRowCoder({ intField: 0, stringField: "" }));
                // [END schema_def]
            }, _tct_transform_64.__closure = () => ({ beam }), _tct_transform_64));
        }, _tct_transform_62.__closure = () => ({ beam }), _tct_transform_62));
        it("logical_types", (_tct_transform_63 = async function () {
            var _tct_transform_65;
            await beam.createRunner().run((_tct_transform_65 = async (root) => {
                var _tct_transform_66;
                // [START schema_logical_register]
                class Foo {
                    constructor(value) {
                        this.value = value;
                    }
                }
                requireForSerialization("apache-beam", { Foo });
                row_coder.registerLogicalType({
                    urn: "beam:logical_type:typescript_foo:v1",
                    reprType: row_coder.RowCoder.inferTypeFromJSON("string", false),
                    toRepr: (foo) => foo.value,
                    fromRepr: (_tct_transform_66 = (value) => new Foo(value), _tct_transform_66.__closure = () => ({ Foo }), _tct_transform_66),
                });
                // [END schema_logical_register]
                // [START schema_logical_use]
                const pcoll = root
                    .apply(beam.create([new Foo("a"), new Foo("b")]))
                    // Use beamLogicalType in the exemplar to indicate its use.
                    .apply(beam.withRowCoder({
                    beamLogicalType: "beam:logical_type:typescript_foo:v1",
                }));
                // [END schema_logical_use]
            }, _tct_transform_65.__closure = () => ({ Foo, value, requireForSerialization, row_coder, beam }), _tct_transform_65));
        }, _tct_transform_63.__closure = () => ({ beam, Foo, value, requireForSerialization, row_coder }), _tct_transform_63));
    }, _tct_transform_10.__closure = () => ({ it, beam, Foo, value, requireForSerialization, row_coder }), _tct_transform_10));
    // TODO: Enable cross-language after next release or set up dev virtual env.
    describe("MultiLangauge", (_tct_transform_11 = function () {
        var _tct_transform_67, _tct_transform_68, _tct_transform_69;
        needs_ulr_it("python_map", (_tct_transform_67 = async function () {
            var _tct_transform_70;
            await beam.createRunner().run((_tct_transform_70 = async (root) => {
                const pcoll = root.apply(beam.create([
                    { a: 1, b: 10 },
                    { a: 2, b: 20 },
                ]));
                // [START python_map]
                const result = await pcoll
                    .apply(beam.withName("UpdateCoder1", beam.withRowCoder({ a: 0, b: 0 })))
                    .applyAsync(pythonTransform(
                // Fully qualified name
                "apache_beam.transforms.Map", 
                // Positional arguments
                [pythonCallable("lambda x: x.a + x.b")], 
                // Keyword arguments
                {}, 
                // Output type if it cannot be inferred
                { requestedOutputCoders: { output: new VarIntCoder() } }));
                // [END python_map]
                result.apply(assertDeepEqual([11, 22]));
            }, _tct_transform_70.__closure = () => ({ beam, pythonTransform, pythonCallable, VarIntCoder, assertDeepEqual }), _tct_transform_70));
        }, _tct_transform_67.__closure = () => ({ beam, pythonTransform, pythonCallable, VarIntCoder, assertDeepEqual }), _tct_transform_67)).timeout(10000);
        needs_ulr_it("stateful_dofn", (_tct_transform_68 = async function () {
            var _tct_transform_71;
            await beam.createRunner().run((_tct_transform_71 = async (root) => {
                // [START stateful_dofn]
                const pcoll = root.apply(beam.create([
                    { key: "a", value: 1 },
                    { key: "b", value: 10 },
                    { key: "a", value: 100 },
                ]));
                const result = await pcoll
                    .apply(withCoderInternal(new KVCoder(new StrUtf8Coder(), new VarIntCoder())))
                    .applyAsync(pythonTransform(
                // Construct a new Transform from source.
                "__constructor__", [
                    pythonCallable(`
                # Define a DoFn to be used below.
                class ReadModifyWriteStateDoFn(beam.DoFn):
                  STATE_SPEC = beam.transforms.userstate.ReadModifyWriteStateSpec(
                      'num_elements', beam.coders.VarIntCoder())

                  def process(self, element, state=beam.DoFn.StateParam(STATE_SPEC)):
                    current_value = state.read() or 0
                    state.write(current_value + 1)
                    yield current_value + 1

                class MyPythonTransform(beam.PTransform):
                  def expand(self, pcoll):
                    return pcoll | beam.ParDo(ReadModifyWriteStateDoFn())
              `),
                ], 
                // Keyword arguments to pass to the transform, if any.
                {}, 
                // Output type if it cannot be inferred
                { requestedOutputCoders: { output: new VarIntCoder() } }));
                // [END stateful_dofn]
                result.apply(assertDeepEqual([1, 1, 2]));
            }, _tct_transform_71.__closure = () => ({ beam, withCoderInternal, KVCoder, StrUtf8Coder, VarIntCoder, pythonTransform, pythonCallable, assertDeepEqual }), _tct_transform_71));
        }, _tct_transform_68.__closure = () => ({ beam, withCoderInternal, KVCoder, StrUtf8Coder, VarIntCoder, pythonTransform, pythonCallable, assertDeepEqual }), _tct_transform_68)).timeout(10000);
        needs_ulr_it("cross_lang_transform", (_tct_transform_69 = async function () {
            var _tct_transform_72;
            await beam.createRunner().run((_tct_transform_72 = async (root) => {
                const pcoll = root.apply(beam.create(["a", "bb"]));
                // [START cross_lang_transform]
                const result = await pcoll
                    .apply(withCoderInternal(new StrUtf8Coder()))
                    .applyAsync(pythonTransform(
                // Define an arbitrary transform from a callable.
                "__callable__", [
                    pythonCallable(`
              def apply(pcoll, prefix, postfix):
                return pcoll | beam.Map(lambda s: prefix + s + postfix)
              `),
                ], 
                // Keyword arguments to pass above, if any.
                { prefix: "x", postfix: "y" }, 
                // Output type if it cannot be inferred
                { requestedOutputCoders: { output: new StrUtf8Coder() } }));
                // [END cross_lang_transform]
                result.apply(assertDeepEqual(["xay", "xbby"]));
            }, _tct_transform_72.__closure = () => ({ beam, withCoderInternal, StrUtf8Coder, pythonTransform, pythonCallable, assertDeepEqual }), _tct_transform_72));
        }, _tct_transform_69.__closure = () => ({ beam, withCoderInternal, StrUtf8Coder, pythonTransform, pythonCallable, assertDeepEqual }), _tct_transform_69)).timeout(10000);
    }, _tct_transform_11.__closure = () => ({ needs_ulr_it, beam, pythonTransform, pythonCallable, VarIntCoder, assertDeepEqual, withCoderInternal, KVCoder, StrUtf8Coder }), _tct_transform_11));
}, _tct_transform_3.__closure = () => ({ describe, it, beam, textio, require, assertDeepEqual, combiners, Math, pardo, Long, windowings, needs_ulr_it, Foo, value, requireForSerialization, row_coder, pythonTransform, pythonCallable, VarIntCoder, withCoderInternal, KVCoder, StrUtf8Coder }), _tct_transform_3));
//# sourceMappingURL=programming_guide.js.map