"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function xlang_it(name, fn) {
    return (process.env.BEAM_SERVICE_OVERRIDES ? it : it.skip)(name + " @xlang", fn);
}
var _tct_transform_1, _tct_transform_2, _tct_transform_3;
xlang_it.__closure = () => ({ process, it });
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const os = require("os");
const path = require("path");
const { BigQuery } = require("@google-cloud/bigquery");
const { PubSub } = require("@google-cloud/pubsub");
const _tct_flatten_destructured_imports_1 = __importStar(require("uuid"));
var uuid = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("assert"));
var assert = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("../src/apache_beam"));
var beam = _tct_flatten_destructured_imports_3;
const _tct_flatten_destructured_imports_4 = __importStar(require("../src/apache_beam/testing/assert"));
var testing = _tct_flatten_destructured_imports_4;
const _tct_flatten_destructured_imports_5 = __importStar(require("../src/apache_beam/transforms/internal"));
var internal = _tct_flatten_destructured_imports_5;
const _tct_flatten_destructured_imports_6 = __importStar(require("../src/apache_beam/runners/runner"));
var createRunner = _tct_flatten_destructured_imports_6.createRunner;
const _tct_flatten_destructured_imports_7 = __importStar(require("../src/apache_beam/coders/required_coders"));
var BytesCoder = _tct_flatten_destructured_imports_7.BytesCoder;
const _tct_flatten_destructured_imports_8 = __importStar(require("../src/apache_beam/coders/row_coder"));
var RowCoder = _tct_flatten_destructured_imports_8.RowCoder;
const _tct_flatten_destructured_imports_9 = __importStar(require("../src/apache_beam/io/avroio"));
var avroio = _tct_flatten_destructured_imports_9;
const _tct_flatten_destructured_imports_10 = __importStar(require("../src/apache_beam/io/bigqueryio"));
var bigqueryio = _tct_flatten_destructured_imports_10;
const _tct_flatten_destructured_imports_11 = __importStar(require("../src/apache_beam/io/parquetio"));
var parquetio = _tct_flatten_destructured_imports_11;
const _tct_flatten_destructured_imports_12 = __importStar(require("../src/apache_beam/io/textio"));
var textio = _tct_flatten_destructured_imports_12;
const _tct_flatten_destructured_imports_13 = __importStar(require("../src/apache_beam/io/pubsub"));
var pubsub = _tct_flatten_destructured_imports_13;
const _tct_flatten_destructured_imports_14 = __importStar(require("../src/apache_beam/utils/service"));
var service = _tct_flatten_destructured_imports_14;
const lines = [
    "In the beginning God created the heaven and the earth.",
    "And the earth was without form, and void; and darkness was upon the face of the deep.",
    "And the Spirit of God moved upon the face of the waters.",
    "And God said, Let there be light: and there was light.",
];
const elements = [
    { label: "11a", rank: 0 },
    { label: "37a", rank: 1 },
    { label: "389a", rank: 2 },
];
let subprocessCache;
before((_tct_transform_1 = () => {
    subprocessCache = service.SubprocessService.createCache();
}, _tct_transform_1.__closure = () => ({ subprocessCache, service }), _tct_transform_1));
after((_tct_transform_2 = () => subprocessCache.stopAll(), _tct_transform_2.__closure = () => ({ subprocessCache }), _tct_transform_2));
// These depends on fixes that will be released in 2.40.
// They can be run manually by setting an environment variable
// export BEAM_SERVICE_OVERRIDES = '{python:*": "/path/to/dev/venv/bin/python"}'
// TODO: Automatically set up/depend on such a venv in dev environments and/or
// testing infra.
describe("IO Tests", (_tct_transform_3 = function () {
    var _tct_transform_4, _tct_transform_5, _tct_transform_6, _tct_transform_7, _tct_transform_8, _tct_transform_9, _tct_transform_10;
    xlang_it("textio file test", (_tct_transform_4 = async function () {
        var _tct_transform_11, _tct_transform_12;
        const tempDir = fs.mkdtempSync(path.join(os.tmpdir(), "apache-beam-test"));
        await createRunner().run((_tct_transform_11 = async (root) => {
            await root //
                .apply(beam.create(lines))
                .applyAsync(textio.writeToText(path.join(tempDir, "out.txt")));
        }, _tct_transform_11.__closure = () => ({ beam, lines, textio, path, tempDir }), _tct_transform_11));
        await createRunner().run((_tct_transform_12 = async (root) => {
            (await root.applyAsync(textio.readFromText(path.join(tempDir, "out.txt*")))).apply(testing.assertDeepEqual(lines));
        }, _tct_transform_12.__closure = () => ({ textio, path, tempDir, testing, lines }), _tct_transform_12));
    }, _tct_transform_4.__closure = () => ({ fs, path, os, createRunner, beam, lines, textio, testing }), _tct_transform_4)).timeout(15000);
    xlang_it("textio csv file test", (_tct_transform_5 = async function () {
        var _tct_transform_13, _tct_transform_14;
        const tempDir = fs.mkdtempSync(path.join(os.tmpdir(), "apache-beam-test"));
        await createRunner().run((_tct_transform_13 = async (root) => {
            await root //
                .apply(beam.create(elements))
                .apply(internal.withCoderInternal(RowCoder.fromJSON(elements[0])))
                .applyAsync(textio.writeToCsv(path.join(tempDir, "out.csv")));
        }, _tct_transform_13.__closure = () => ({ beam, elements, internal, RowCoder, textio, path, tempDir }), _tct_transform_13));
        console.log(tempDir);
        await createRunner().run((_tct_transform_14 = async (root) => {
            (await root.applyAsync(textio.readFromCsv(path.join(tempDir, "out.csv*")))).apply(testing.assertDeepEqual(elements));
        }, _tct_transform_14.__closure = () => ({ textio, path, tempDir, testing, elements }), _tct_transform_14));
    }, _tct_transform_5.__closure = () => ({ fs, path, os, createRunner, beam, elements, internal, RowCoder, textio, console, testing }), _tct_transform_5)).timeout(15000);
    xlang_it("textio json file test", (_tct_transform_6 = async function () {
        var _tct_transform_15, _tct_transform_16;
        const tempDir = fs.mkdtempSync(path.join(os.tmpdir(), "apache-beam-test"));
        await createRunner().run((_tct_transform_15 = async (root) => {
            await root //
                .apply(beam.create(elements))
                .apply(internal.withCoderInternal(RowCoder.fromJSON(elements[0])))
                .applyAsync(textio.writeToJson(path.join(tempDir, "out.json")));
        }, _tct_transform_15.__closure = () => ({ beam, elements, internal, RowCoder, textio, path, tempDir }), _tct_transform_15));
        await createRunner().run((_tct_transform_16 = async (root) => {
            (await root.applyAsync(textio.readFromJson(path.join(tempDir, "out.json*")))).apply(testing.assertDeepEqual(elements));
        }, _tct_transform_16.__closure = () => ({ textio, path, tempDir, testing, elements }), _tct_transform_16));
    }, _tct_transform_6.__closure = () => ({ fs, path, os, createRunner, beam, elements, internal, RowCoder, textio, testing }), _tct_transform_6)).timeout(15000);
    xlang_it("parquetio file test", (_tct_transform_7 = async function () {
        var _tct_transform_17, _tct_transform_18, _tct_transform_19;
        const tempDir = fs.mkdtempSync(path.join(os.tmpdir(), "apache-beam-test"));
        await createRunner().run((_tct_transform_17 = async (root) => {
            await root //
                .apply(beam.create(elements))
                .apply(internal.withCoderInternal(RowCoder.fromJSON(elements[0])))
                .applyAsync(parquetio.writeToParquet(path.join(tempDir, "out.parquet")));
        }, _tct_transform_17.__closure = () => ({ beam, elements, internal, RowCoder, parquetio, path, tempDir }), _tct_transform_17));
        await createRunner().run((_tct_transform_18 = async (root) => {
            (await root.applyAsync(parquetio.readFromParquet(path.join(tempDir, "out.parquet*")))).apply(testing.assertDeepEqual(elements));
        }, _tct_transform_18.__closure = () => ({ parquetio, path, tempDir, testing, elements }), _tct_transform_18));
        await createRunner().run((_tct_transform_19 = async (root) => {
            (await root.applyAsync(parquetio.readFromParquet(path.join(tempDir, "out.parquet*"), {
                columns: ["label", "rank"],
            }))).apply(testing.assertDeepEqual(elements));
        }, _tct_transform_19.__closure = () => ({ parquetio, path, tempDir, testing, elements }), _tct_transform_19));
    }, _tct_transform_7.__closure = () => ({ fs, path, os, createRunner, beam, elements, internal, RowCoder, parquetio, testing }), _tct_transform_7)).timeout(15000);
    it.skip("avroio file test", (_tct_transform_8 = async function () {
        // TODO: Allow local testing.
        // const tempDir = fs.mkdtempSync(path.join(os.tmpdir(), "apache-beam-test"));
        function path_join(...args) {
            return path.join(...args).replace("gs:/", "gs://");
        }
        var _tct_transform_20, _tct_transform_21;
        path_join.__closure = () => ({ path });
        // Requires access to a distributed filesystem.
        const options = {
            //      runner: "dataflow",
            project: "apache-beam-testing",
            tempLocation: "gs://temp-storage-for-end-to-end-tests/temp-it",
            region: "us-central1",
        };
        const tempDir = path_join(options.tempLocation, uuid.v4());
        console.log(options.tempLocation);
        console.log(tempDir);
        // TODO: Allow schema to be inferred.
        const schema = RowCoder.inferSchemaOfJSON(elements[0]);
        await createRunner(options).run((_tct_transform_20 = async (root) => {
            await root //
                .apply(beam.create(elements))
                .applyAsync(avroio.writeToAvro(path_join(tempDir, "out.avro"), { schema }));
        }, _tct_transform_20.__closure = () => ({ beam, elements, avroio, path_join, tempDir, schema }), _tct_transform_20));
        await createRunner(options).run((_tct_transform_21 = async (root) => {
            (await root.applyAsync(avroio.readFromAvro(path_join(tempDir, "out.avro*"), { schema }))).apply(testing.assertDeepEqual(elements));
        }, _tct_transform_21.__closure = () => ({ avroio, path_join, tempDir, schema, testing, elements }), _tct_transform_21));
    }, _tct_transform_8.__closure = () => ({ path, uuid, console, RowCoder, elements, createRunner, beam, avroio, testing }), _tct_transform_8)).timeout(60000);
    it.skip("bigqueryio test", (_tct_transform_9 = async function () {
        var _tct_transform_22, _tct_transform_23, _tct_transform_24;
        // This only passes when it is run on its own.
        // TODO: Figure out what is going on here.
        // The error is a java.lang.NullPointerException at
        // org.apache.beam.sdk.io.gcp.bigquery.BigQueryTableSourceDef.getBeamSchema(BigQueryTableSourceDef.java:111)
        this.skip();
        // TODO: There should be a better way to pass this to the underlying
        // services.
        if (!process.env.CLOUDSDK_CONFIG) {
            const cloudSdkConfig = fs.mkdtempSync(path.join(os.tmpdir(), "apache-beam-test"));
            fs.writeFileSync(path.join(cloudSdkConfig, "properties"), "project=apache-beam-testing");
            process.env.CLOUDSDK_CONFIG = cloudSdkConfig;
        }
        if (!process.env.GOOGLE_APPLICATION_CREDENTIALS) {
            const defaultCredentials = path.join(os.homedir(), ".config", "gcloud", "application_default_credentials.json");
            if (fs.existsSync(defaultCredentials)) {
                process.env.GOOGLE_APPLICATION_CREDENTIALS = defaultCredentials;
            }
        }
        const options = {
            project: "apache-beam-testing",
            tempLocation: "gs://temp-storage-for-end-to-end-tests/temp-it",
            region: "us-central1",
        };
        const bigqueryClient = new BigQuery({ projectId: options.project });
        const datasetName = "beam_temp_dataset_" + uuid.v4().replaceAll("-", "");
        const [dataset] = await bigqueryClient.createDataset(datasetName);
        try {
            const table = datasetName + ".beam_temp_table" + uuid.v4().replaceAll("-", "");
            await createRunner(options).run((_tct_transform_22 = async (root) => {
                await root //
                    .apply(beam.create(elements))
                    .apply(internal.withCoderInternal(RowCoder.fromJSON(elements[0])))
                    .applyAsync(bigqueryio.writeToBigQuery(table, { createDisposition: "IfNeeded" }));
            }, _tct_transform_22.__closure = () => ({ beam, elements, internal, RowCoder, bigqueryio, table }), _tct_transform_22));
            await createRunner(options).run((_tct_transform_23 = async (root) => {
                (await root.applyAsync(bigqueryio.readFromBigQuery({ table }))) //
                    .apply(testing.assertDeepEqual(elements));
            }, _tct_transform_23.__closure = () => ({ bigqueryio, table, testing, elements }), _tct_transform_23));
            await createRunner(options).run((_tct_transform_24 = async (root) => {
                (await root.applyAsync(bigqueryio.readFromBigQuery({
                    query: `SELECT label, rank FROM ${table}`,
                }))) //
                    .apply(testing.assertDeepEqual(elements));
            }, _tct_transform_24.__closure = () => ({ bigqueryio, table, testing, elements }), _tct_transform_24));
        }
        finally {
            await dataset.delete({ force: true });
        }
    }, _tct_transform_9.__closure = () => ({ process, fs, path, os, BigQuery, uuid, createRunner, beam, elements, internal, RowCoder, bigqueryio, testing }), _tct_transform_9)).timeout(300000);
    it.skip("pubsub test", (_tct_transform_10 = async function () {
        var _tct_transform_25, _tct_transform_26;
        const options = {
            runner: "dataflow",
            project: "apache-beam-testing",
            tempLocation: "gs://temp-storage-for-end-to-end-tests/temp-it",
            region: "us-central1",
        };
        const pubsubClient = new PubSub({ projectId: options.project });
        const [readTopic] = await pubsubClient.createTopic("testing-" + uuid.v4());
        const [readSubscription] = await readTopic.createSubscription("sub-" + uuid.v4());
        const [writeTopic] = await pubsubClient.createTopic("testing-" + uuid.v4());
        const [writeSubscription] = await writeTopic.createSubscription("sub-" + uuid.v4());
        let pipelineHandle;
        try {
            pipelineHandle = await createRunner(options).runAsync((_tct_transform_25 = async (root) => {
                var _tct_transform_27, _tct_transform_28;
                await (await root.applyAsync(pubsub.readFromPubSub({
                    subscription: readSubscription.name,
                })))
                    .map((_tct_transform_27 = (encoded) => new TextDecoder().decode(encoded), _tct_transform_27.__closure = () => ({ TextDecoder }), _tct_transform_27))
                    .map((msg) => msg.toUpperCase())
                    .map((_tct_transform_28 = (msg) => new TextEncoder().encode(msg), _tct_transform_28.__closure = () => ({ TextEncoder }), _tct_transform_28))
                    .apply(internal.withCoderInternal(new BytesCoder()))
                    .applyAsync(pubsub.writeToPubSub(writeTopic.name));
            }, _tct_transform_25.__closure = () => ({ pubsub, readSubscription, TextDecoder, TextEncoder, internal, BytesCoder, writeTopic }), _tct_transform_25));
            console.log("Pipeline started", pipelineHandle.jobId);
            console.log("Publishing");
            for (const line of lines) {
                readTopic.publish(Buffer.from(line));
            }
            console.log("Reading");
            const received = [];
            await new Promise((_tct_transform_26 = (resolve, reject) => {
                var _tct_transform_29;
                return writeSubscription.on("message", (_tct_transform_29 = (message) => {
                    received.push(message.data.toString());
                    if (received.length == lines.length) {
                        resolve();
                    }
                    message.ack();
                }, _tct_transform_29.__closure = () => ({ received, lines, resolve }), _tct_transform_29));
            }, _tct_transform_26.__closure = () => ({ writeSubscription, received, lines }), _tct_transform_26));
            assert.deepEqual(received.sort(), lines.map((s) => s.toUpperCase()).sort());
        }
        finally {
            console.log("Cleaning up");
            await writeSubscription.delete();
            await readTopic.delete();
            await writeTopic.delete();
            if (pipelineHandle) {
                await pipelineHandle.cancel();
            }
        }
    }, _tct_transform_10.__closure = () => ({ PubSub, uuid, createRunner, pubsub, TextDecoder, TextEncoder, internal, BytesCoder, console, lines, Buffer, Promise, assert }), _tct_transform_10)).timeout(600000);
}, _tct_transform_3.__closure = () => ({ xlang_it, fs, path, os, createRunner, beam, lines, textio, testing, elements, internal, RowCoder, console, parquetio, it, uuid, avroio, process, BigQuery, bigqueryio, PubSub, pubsub, TextDecoder, TextEncoder, BytesCoder, Buffer, Promise, assert }), _tct_transform_3));
//# sourceMappingURL=io_test.js.map