"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function sortValues(kvs) {
    return { key: kvs.key, value: [...kvs.value].sort() };
}
function suite(runner = directRunner()) {
    describe("testing.assertDeepEqual", (_tct_transform_1 = function () {
        var _tct_transform_8;
        // The tests below won't catch failures if this doesn't fail.
        it("fails on bad assert", (_tct_transform_8 = async function () {
            var _tct_transform_9;
            // TODO: There's probably a more idiomatic way to test failures.
            var seenError = false;
            try {
                await runner.run((_tct_transform_9 = (root) => {
                    const pcolls = root
                        .apply(beam.create([1, 2, 3]))
                        .apply(testing.assertDeepEqual([1, 2]));
                }, _tct_transform_9.__closure = () => ({ beam, testing }), _tct_transform_9));
            }
            catch (Error) {
                seenError = true;
            }
            assert.equal(true, seenError);
        }, _tct_transform_8.__closure = () => ({ runner, beam, testing, assert }), _tct_transform_8));
    }, _tct_transform_1.__closure = () => ({ 
        // The tests below won't catch failures if this doesn't fail.
        it, runner, beam, testing, assert }), _tct_transform_1));
    describe("runs basic transforms", (_tct_transform_2 = function () {
        var _tct_transform_10, _tct_transform_11, _tct_transform_12, _tct_transform_13, _tct_transform_14, _tct_transform_15, _tct_transform_16, _tct_transform_17, _tct_transform_18, _tct_transform_19;
        it("runs a map", (_tct_transform_10 = async function () {
            var _tct_transform_20;
            await runner.run((_tct_transform_20 = (root) => {
                const pcolls = root
                    .apply(beam.create([1, 2, 3]))
                    .map((x) => x * x)
                    .apply(testing.assertDeepEqual([1, 4, 9]));
            }, _tct_transform_20.__closure = () => ({ beam, testing }), _tct_transform_20));
        }, _tct_transform_10.__closure = () => ({ runner, beam, testing }), _tct_transform_10));
        it("runs a flatmap", (_tct_transform_11 = async function () {
            var _tct_transform_21;
            await runner.run((_tct_transform_21 = (root) => {
                const pcolls = root
                    .apply(beam.create(["a b", "c"]))
                    .flatMap((s) => s.split(/ +/))
                    .apply(testing.assertDeepEqual(["a", "b", "c"]));
            }, _tct_transform_21.__closure = () => ({ beam, testing }), _tct_transform_21));
        }, _tct_transform_11.__closure = () => ({ runner, beam, testing }), _tct_transform_11));
        it("runs a Splitter", (_tct_transform_12 = async function () {
            var _tct_transform_22;
            await runner.run((_tct_transform_22 = (root) => {
                const pcolls = root
                    .apply(beam.create([{ a: 1 }, { b: 10 }, { a: 2, b: 20 }]))
                    .apply(beam.split(["a", "b"], { exclusive: false }));
                pcolls.a.apply(testing.assertDeepEqual([1, 2]));
                pcolls.b.apply(testing.assertDeepEqual([10, 20]));
            }, _tct_transform_22.__closure = () => ({ beam, testing }), _tct_transform_22));
        }, _tct_transform_12.__closure = () => ({ runner, beam, testing }), _tct_transform_12));
        it("runs a map with context", (_tct_transform_13 = async function () {
            var _tct_transform_23;
            await runner.run((_tct_transform_23 = (root) => {
                root
                    .apply(beam.create([1, 2, 3]))
                    .map((a, b) => a + b, 100)
                    .apply(testing.assertDeepEqual([101, 102, 103]));
            }, _tct_transform_23.__closure = () => ({ beam, testing }), _tct_transform_23));
        }, _tct_transform_13.__closure = () => ({ runner, beam, testing }), _tct_transform_13));
        it("runs a map with counters", (_tct_transform_14 = async function () {
            var _tct_transform_24;
            const result = await runner.run((_tct_transform_24 = (root) => {
                root
                    .apply(beam.create([1, 2, 3]))
                    .map(withName("mapWithCounter", pardo.withContext((x, context) => {
                    context.myCounter.increment(x);
                    context.myDist.update(x);
                    return x * x;
                }, {
                    myCounter: pardo.counter("myCounter"),
                    myDist: pardo.distribution("myDist"),
                })))
                    .apply(testing.assertDeepEqual([1, 4, 9]));
            }, _tct_transform_24.__closure = () => ({ beam, withName, pardo, testing }), _tct_transform_24));
            assert.deepEqual((await result.counters()).myCounter, 1 + 2 + 3);
            assert.deepEqual((await result.distributions()).myDist, {
                count: 3,
                sum: 6,
                min: 1,
                max: 3,
            });
        }, _tct_transform_14.__closure = () => ({ runner, beam, withName, pardo, testing, assert }), _tct_transform_14));
        it("runs a map with singleton side input", (_tct_transform_15 = async function () {
            var _tct_transform_25;
            await runner.run((_tct_transform_25 = (root) => {
                const input = root.apply(beam.create([1, 2, 1]));
                const sideInput = root.apply(beam.withName("createSide", beam.create([4])));
                input
                    .map((e, context) => e / context.side.lookup(), {
                    side: pardo.singletonSideInput(sideInput),
                })
                    .apply(testing.assertDeepEqual([0.25, 0.5, 0.25]));
            }, _tct_transform_25.__closure = () => ({ beam, pardo, testing }), _tct_transform_25));
        }, _tct_transform_15.__closure = () => ({ runner, beam, pardo, testing }), _tct_transform_15));
        it("runs a map with a side input sharing input root", (_tct_transform_16 = async function () {
            var _tct_transform_26;
            await runner.run((_tct_transform_26 = (root) => {
                const input = root.apply(beam.create([1, 2, 1]));
                // TODO: Can this type be inferred?
                const sideInput = input.apply(beam.groupGlobally().combining((e) => e, combiners.sum, "sum"));
                input
                    .map((e, context) => e / context.side.lookup().sum, {
                    side: pardo.singletonSideInput(sideInput),
                })
                    .apply(testing.assertDeepEqual([0.25, 0.5, 0.25]));
            }, _tct_transform_26.__closure = () => ({ beam, combiners, pardo, testing }), _tct_transform_26));
        }, _tct_transform_16.__closure = () => ({ runner, beam, combiners, pardo, testing }), _tct_transform_16));
        it("runs a map with window-sensitive context", (_tct_transform_17 = async function () {
            var _tct_transform_27;
            await runner.run((_tct_transform_27 = (root) => {
                var _tct_transform_28;
                root
                    .apply(beam.create([1, 2, 3, 4, 5, 10, 11, 12]))
                    .apply(beam.assignTimestamps((_tct_transform_28 = (t) => Long.fromValue(t * 1000), _tct_transform_28.__closure = () => ({ Long }), _tct_transform_28)))
                    .apply(beam.windowInto(windowings.fixedWindows(10)))
                    .apply(beam.groupBy((e) => ""))
                    .map(withName("MapWithContext", pardo.withContext(
                // This is the function to apply.
                (kv, context) => {
                    return {
                        key: kv.key,
                        value: [...kv.value].sort(),
                        window_start_ms: context.window.lookup().start.low,
                        a: context.other,
                    };
                }, 
                // This is the context to pass as the second argument.
                // At each element, window.get() will return the associated window.
                { window: pardo.windowParam(), other: "A" })))
                    .apply(testing.assertDeepEqual([
                    { key: "", value: [1, 2, 3, 4, 5], window_start_ms: 0, a: "A" },
                    { key: "", value: [10, 11, 12], window_start_ms: 10000, a: "A" },
                ]));
            }, _tct_transform_27.__closure = () => ({ beam, Long, windowings, withName, pardo, testing }), _tct_transform_27));
        }, _tct_transform_17.__closure = () => ({ runner, beam, Long, windowings, withName, pardo, testing }), _tct_transform_17));
        it("runs a WindowInto", (_tct_transform_18 = async function () {
            var _tct_transform_29;
            await runner.run((_tct_transform_29 = (root) => {
                root
                    .apply(beam.create(["apple", "apricot", "banana"]))
                    .apply(beam.windowInto(windowings.globalWindows()))
                    .apply(beam.groupBy((e) => e[0]))
                    .map(sortValues)
                    .apply(testing.assertDeepEqual([
                    { key: "a", value: ["apple", "apricot"] },
                    { key: "b", value: ["banana"] },
                ]));
            }, _tct_transform_29.__closure = () => ({ beam, windowings, sortValues, testing }), _tct_transform_29));
        }, _tct_transform_18.__closure = () => ({ runner, beam, windowings, sortValues, testing }), _tct_transform_18));
        it("runs a WindowInto IntervalWindow", (_tct_transform_19 = async function () {
            var _tct_transform_30;
            await runner.run((_tct_transform_30 = (root) => {
                var _tct_transform_31;
                root
                    .apply(beam.create([1, 2, 3, 4, 5, 10, 11, 12]))
                    .apply(beam.assignTimestamps((_tct_transform_31 = (t) => Long.fromValue(t * 1000), _tct_transform_31.__closure = () => ({ Long }), _tct_transform_31)))
                    .apply(beam.windowInto(windowings.fixedWindows(10)))
                    .apply(beam.groupBy((e) => ""))
                    .map(sortValues)
                    .apply(testing.assertDeepEqual([
                    { key: "", value: [1, 2, 3, 4, 5] },
                    { key: "", value: [10, 11, 12] },
                ]));
            }, _tct_transform_30.__closure = () => ({ beam, Long, windowings, sortValues, testing }), _tct_transform_30));
        }, _tct_transform_19.__closure = () => ({ runner, beam, Long, windowings, sortValues, testing }), _tct_transform_19));
    }, _tct_transform_2.__closure = () => ({ it, runner, beam, testing, withName, pardo, assert, combiners, Long, windowings, sortValues }), _tct_transform_2));
    describe("applies basic transforms", (_tct_transform_3 = function () {
        var _tct_transform_32, _tct_transform_33, _tct_transform_34;
        // TODO: test output with direct runner.
        it("runs a basic Impulse expansion", (_tct_transform_32 = function () {
            var p = new Pipeline();
            var res = new beam.Root(p).apply(beam.impulse());
            assert.deepEqual(p.context.getPCollectionCoder(res), new BytesCoder());
        }, _tct_transform_32.__closure = () => ({ Pipeline, beam, assert, BytesCoder }), _tct_transform_32));
        it("runs a ParDo expansion", (_tct_transform_33 = function () {
            var p = new Pipeline();
            var res = new beam.Root(p)
                .apply(beam.impulse())
                .map(function (v) {
                return v * 2;
            })
                .map(function (v) {
                return v * 4;
            });
            assert.deepEqual(p.context.getPCollectionCoder(res), new GeneralObjectCoder());
        }, _tct_transform_33.__closure = () => ({ Pipeline, beam, assert, GeneralObjectCoder }), _tct_transform_33));
        // why doesn't map need types here?
        it("runs a GroupBy expansion", (_tct_transform_34 = function () {
            var p = new Pipeline();
            var res = new beam.Root(p)
                .apply(beam.impulse())
                .map(function createElement(v) {
                return { name: "pablo", lastName: "wat" };
            })
                .apply(beam.groupBy("lastName"));
            assert.deepEqual(p.context.getPCollectionCoder(res), new KVCoder(new GeneralObjectCoder(), new IterableCoder(new GeneralObjectCoder())));
        }, _tct_transform_34.__closure = () => ({ Pipeline, beam, assert, KVCoder, GeneralObjectCoder, IterableCoder }), _tct_transform_34));
    }, _tct_transform_3.__closure = () => ({ 
        // TODO: test output with direct runner.
        it, Pipeline, beam, assert, BytesCoder, GeneralObjectCoder, KVCoder, IterableCoder }), _tct_transform_3));
}
var _tct_transform_1, _tct_transform_2, _tct_transform_3, _tct_transform_4, _tct_transform_5, _tct_transform_6, _tct_transform_7;
suite.__closure = () => ({ describe, 
    // The tests below won't catch failures if this doesn't fail.
    it, beam, testing, assert, withName, pardo, combiners, Long, windowings, sortValues, Pipeline, BytesCoder, GeneralObjectCoder, KVCoder, IterableCoder });
Object.defineProperty(exports, "__esModule", { value: true });
exports.suite = void 0;
const long_1 = __importStar(require("long")), _tct_flatten_destructured_imports_1 = long_1;
var Long = _tct_flatten_destructured_imports_1.default;
const _tct_flatten_destructured_imports_2 = __importStar(require("../src/apache_beam"));
var beam = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("assert"));
var assert = _tct_flatten_destructured_imports_3;
const _tct_flatten_destructured_imports_4 = __importStar(require("../src/apache_beam/coders/standard_coders"));
var BytesCoder = _tct_flatten_destructured_imports_4.BytesCoder;
var IterableCoder = _tct_flatten_destructured_imports_4.IterableCoder;
var KVCoder = _tct_flatten_destructured_imports_4.KVCoder;
const _tct_flatten_destructured_imports_5 = __importStar(require("../src/apache_beam/transforms/combiners"));
var combiners = _tct_flatten_destructured_imports_5;
const _tct_flatten_destructured_imports_6 = __importStar(require("../src/apache_beam/coders/js_coders"));
var GeneralObjectCoder = _tct_flatten_destructured_imports_6.GeneralObjectCoder;
const _tct_flatten_destructured_imports_7 = __importStar(require("../src/apache_beam/runners/direct_runner"));
var directRunner = _tct_flatten_destructured_imports_7.directRunner;
const _tct_flatten_destructured_imports_8 = __importStar(require("../src/apache_beam/runners/runner"));
var loopbackRunner = _tct_flatten_destructured_imports_8.loopbackRunner;
const _tct_flatten_destructured_imports_9 = __importStar(require("../src/apache_beam/internal/pipeline"));
var Pipeline = _tct_flatten_destructured_imports_9.Pipeline;
const _tct_flatten_destructured_imports_10 = __importStar(require("../src/apache_beam/values"));
var GlobalWindow = _tct_flatten_destructured_imports_10.GlobalWindow;
const _tct_flatten_destructured_imports_11 = __importStar(require("../src/apache_beam/coders/standard_coders"));
var PaneInfoCoder = _tct_flatten_destructured_imports_11.PaneInfoCoder;
const _tct_flatten_destructured_imports_12 = __importStar(require("../src/apache_beam/testing/assert"));
var testing = _tct_flatten_destructured_imports_12;
const _tct_flatten_destructured_imports_13 = __importStar(require("../src/apache_beam/transforms/windowings"));
var windowings = _tct_flatten_destructured_imports_13;
const _tct_flatten_destructured_imports_14 = __importStar(require("../src/apache_beam/transforms/pardo"));
var pardo = _tct_flatten_destructured_imports_14;
const _tct_flatten_destructured_imports_15 = __importStar(require("../src/apache_beam/transforms"));
var withName = _tct_flatten_destructured_imports_15.withName;
const _tct_flatten_destructured_imports_16 = __importStar(require("../src/apache_beam/utils/service"));
var service = _tct_flatten_destructured_imports_16;
const _tct_flatten_destructured_imports_17 = __importStar(require("../src/apache_beam/testing/multi_pipeline_runner"));
var MultiPipelineRunner = _tct_flatten_destructured_imports_17.MultiPipelineRunner;
let subprocessCache;
before((_tct_transform_4 = async function () {
    var _tct_transform_35;
    this.timeout(30000);
    subprocessCache = service.SubprocessService.createCache();
    if (process.env.BEAM_SERVICE_OVERRIDES) {
        // Start it up here so we don't timeout any individual test.
        await loopbackRunner().run((_tct_transform_35 = function pipeline(root) {
            root.apply(beam.impulse());
        }, _tct_transform_35.__closure = () => ({ beam }), _tct_transform_35));
    }
}, _tct_transform_4.__closure = () => ({ subprocessCache, service, process, loopbackRunner, beam }), _tct_transform_4));
after((_tct_transform_5 = () => subprocessCache.stopAll(), _tct_transform_5.__closure = () => ({ subprocessCache }), _tct_transform_5));
exports.suite = suite;
describe("primitives module", (_tct_transform_6 = function () {
    var _tct_transform_36, _tct_transform_37;
    describe("direct runner", suite.bind(this));
    if (process.env.BEAM_SERVICE_OVERRIDES) {
        describe("portable runner @ulr", (_tct_transform_36 = () => {
            suite.bind(this)(loopbackRunner());
        }, _tct_transform_36.__closure = () => ({ suite, loopbackRunner }), _tct_transform_36));
    }
    else {
        it("Portable tests not run because BEAM_SERVICE_OVERRIDES not set.", function () {
            this.skip();
        });
    }
    describe("multi-pipeline @dataflow", (_tct_transform_37 = async () => {
        var _tct_transform_38, _tct_transform_39;
        if (process.env.GCP_PROJECT_ID) {
            if (!process.env.BEAM_SERVICE_OVERRIDES) {
                throw new Error("Please specify BEAM_SERVICE_OVERRIDES env var.");
            }
            if (!process.env.GCP_TESTING_BUCKET) {
                throw new Error("Please specify GCP_REGION env var.");
            }
            if (!process.env.GCP_REGION) {
                throw new Error("Please specify GCP_TESTING_BUCKET env var.");
            }
            const runner = new MultiPipelineRunner(require("../src/apache_beam/runners/dataflow").dataflowRunner({
                project: process.env.GCP_PROJECT_ID,
                tempLocation: process.env.GCP_TESTING_BUCKET,
                region: process.env.GCP_REGION,
            }));
            beforeEach((_tct_transform_38 = function () {
                if (this.test.title.includes("fails") ||
                    this.test.title.includes("counter")) {
                    this.skip();
                }
                runner.setNextTestName(this.test.title.match(/([^"]+)"$/)[1]);
            }, _tct_transform_38.__closure = () => ({ runner }), _tct_transform_38));
            after((_tct_transform_39 = async function () {
                this.timeout(10 * 60 * 1000 /* 10 min */);
                console.log(await runner.reallyRunPipelines());
            }, _tct_transform_39.__closure = () => ({ console, runner }), _tct_transform_39));
            suite.bind(this)(runner);
        }
        else {
            it("Dataflow tests not run because GCP_PROJECT_ID not set.", function () {
                this.skip();
            });
        }
    }, _tct_transform_37.__closure = () => ({ process, Error, MultiPipelineRunner, require, beforeEach, after, console, suite, it }), _tct_transform_37));
}, _tct_transform_6.__closure = () => ({ describe, suite, process, loopbackRunner, it, Error, MultiPipelineRunner, require, beforeEach, after, console }), _tct_transform_6));
describe("liquid sharding @ulr", (_tct_transform_7 = function () {
    var _tct_transform_40;
    if (process.env.BEAM_SERVICE_OVERRIDES) {
        it("handles splitting", (_tct_transform_40 = async function () {
            var _tct_transform_41;
            // This pipeline will process a number of "slow" elements, asking the
            // ULR to split the "toSplit" bundle at various points. We then verify
            // that the bundle was indeed split and all expected elements made it
            // through.
            const runner = loopbackRunner({
                directTestSplits: JSON.stringify({
                    toSplit: {
                        // Split 0.1, 0.15, etc. seconds into processing the bundle.
                        timings: [0.1, 0.15, 0.2, 0.25],
                        fractions: [0.5, 0.5, 0.5, 0.5],
                    },
                }),
            });
            const numElements = 20;
            const elements = [...Array(numElements).keys()].map((x) => "" + x);
            await runner.run((_tct_transform_41 = (root) => {
                var _tct_transform_42, _tct_transform_43;
                const pcolls = root
                    .apply(beam.create(elements))
                    .map((_tct_transform_42 = (x) => {
                    // Synchronous sleep.
                    Atomics.wait(new Int32Array(new SharedArrayBuffer(4)), 0, 0, 
                    // Processing all elements spread out over 1000 ms, plus overhead.
                    1000 / numElements);
                    return x;
                }, _tct_transform_42.__closure = () => ({ 
                    // Synchronous sleep.
                    Atomics, Int32Array, SharedArrayBuffer, numElements }), _tct_transform_42))
                    .apply(withName("toSplit", beam.parDo({
                    process: (element) => [element],
                    finishBundle: (_tct_transform_43 = () => [
                        {
                            value: "endOfBundle",
                            windows: [new GlobalWindow()],
                            pane: PaneInfoCoder.ONE_AND_ONLY_FIRING,
                            timestamp: new GlobalWindow().maxTimestamp(),
                        },
                    ], _tct_transform_43.__closure = () => ({ GlobalWindow, PaneInfoCoder }), _tct_transform_43),
                })))
                    .apply(
                // More than one "endOfBundle" output because we split.
                // (We in fact should have split this first bundle multiple times,
                // but all the remainders get processed in a (single) second bundle.
                // Importantly, however, we verify that regardless of where the
                // splits occurred (if you print them, they're in an interesting
                // order), all elements are accounted for.)
                testing.assertDeepEqual(elements.concat(["endOfBundle", "endOfBundle"])));
            }, _tct_transform_41.__closure = () => ({ beam, elements, 
                // Synchronous sleep.
                Atomics, Int32Array, SharedArrayBuffer, numElements, withName, GlobalWindow, PaneInfoCoder, testing }), _tct_transform_41));
            // The pipeline should run fast, but give plenty of time for the service
            // to start up in case the test machine is loaded.
        }, _tct_transform_40.__closure = () => ({ loopbackRunner, JSON, Array, beam, 
            // Synchronous sleep.
            Atomics, Int32Array, SharedArrayBuffer, withName, GlobalWindow, PaneInfoCoder, testing }), _tct_transform_40)).timeout(30000);
    }
}, _tct_transform_7.__closure = () => ({ process, it, loopbackRunner, JSON, Array, beam, 
    // Synchronous sleep.
    Atomics, Int32Array, SharedArrayBuffer, withName, GlobalWindow, PaneInfoCoder, testing }), _tct_transform_7));
//# sourceMappingURL=primitives_test.js.map