"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function bufferingDataChannel() {
    const bufferedData = [];
    const bufferedTimers = [];
    let closed = { value: undefined };
    closed.value = false;
    let error = undefined;
    return {
        sendData: (_tct_transform_1 = function (data) {
            bufferedData.push(data);
            return Promise.resolve();
        }, _tct_transform_1.__closure = () => ({ bufferedData, Promise }), _tct_transform_1),
        sendTimers: (_tct_transform_2 = function (timerFamilyId, timers) {
            bufferedTimers.push([timerFamilyId, timers]);
            return Promise.resolve();
        }, _tct_transform_2.__closure = () => ({ bufferedTimers, Promise }), _tct_transform_2),
        close: (_tct_transform_3 = function () {
            closed.value = true;
        }, _tct_transform_3.__closure = () => ({ closed }), _tct_transform_3),
        onError: (_tct_transform_4 = function (error) {
            closed.value = true;
            error = error;
        }, _tct_transform_4.__closure = () => ({ closed }), _tct_transform_4),
        flush: (_tct_transform_5 = async function (channel) {
            for (const datum of bufferedData) {
                await channel.sendData(datum);
            }
            for (const [timerFamilyId, timers] of bufferedTimers) {
                await channel.sendTimers(timerFamilyId, timers);
            }
            if (error) {
                channel.onError(error);
            }
            if (closed.value) {
                channel.close();
            }
        }, _tct_transform_5.__closure = () => ({ bufferedData, bufferedTimers, error, closed }), _tct_transform_5),
    };
}
var _tct_transform_1, _tct_transform_2, _tct_transform_3, _tct_transform_4, _tct_transform_5, _tct_transform_6, _tct_transform_7, _tct_transform_8, _tct_transform_9;
bufferingDataChannel.__closure = () => ({ Promise });
function truncateOnErrorDataChannel(underlying) {
    let seenError = { value: undefined };
    seenError.value = false;
    return {
        sendData: (_tct_transform_6 = function (data) {
            if (seenError.value) {
                return Promise.resolve();
            }
            return underlying.sendData(data);
        }, _tct_transform_6.__closure = () => ({ seenError, Promise, underlying }), _tct_transform_6),
        sendTimers: (_tct_transform_7 = function (timerFamilyId, timers) {
            if (seenError.value) {
                return Promise.resolve();
            }
            return underlying.sendTimers(timerFamilyId, timers);
        }, _tct_transform_7.__closure = () => ({ seenError, Promise, underlying }), _tct_transform_7),
        close: (_tct_transform_8 = function () {
            underlying.close();
        }, _tct_transform_8.__closure = () => ({ underlying }), _tct_transform_8),
        onError: (_tct_transform_9 = function (error) {
            console.error("DATA ERROR", error);
            seenError.value = true;
            underlying.onError(error);
        }, _tct_transform_9.__closure = () => ({ console, seenError, underlying }), _tct_transform_9),
    };
}
truncateOnErrorDataChannel.__closure = () => ({ Promise, console });
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultiplexingDataChannel = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("@grpc/grpc-js"));
var grpc = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../proto/beam_fn_api"));
var Elements = _tct_flatten_destructured_imports_2.Elements;
const _tct_flatten_destructured_imports_3 = __importStar(require("../proto/beam_fn_api"));
var ProcessBundleDescriptor = _tct_flatten_destructured_imports_3.ProcessBundleDescriptor;
var ProcessBundleResponse = _tct_flatten_destructured_imports_3.ProcessBundleResponse;
const _tct_flatten_destructured_imports_4 = __importStar(require("../proto/beam_fn_api.grpc-client"));
var BeamFnDataClient = _tct_flatten_destructured_imports_4.BeamFnDataClient;
var IBeamFnDataClient = _tct_flatten_destructured_imports_4.IBeamFnDataClient;
class MultiplexingDataChannel {
    constructor(endpoint, workerId) {
        var _tct_transform_10, _tct_transform_11;
        this.consumers = new Map();
        const metadata = new grpc.Metadata();
        metadata.add("worker_id", workerId);
        this.dataClient = new BeamFnDataClient(endpoint, grpc.ChannelCredentials.createInsecure(), {}, {});
        this.dataChannel = this.dataClient.data(metadata);
        this.dataChannel.on("data", (_tct_transform_10 = async (elements) => {
            console.debug("data", elements);
            for (const data of elements.data) {
                const consumer = this.getConsumer(data.instructionId, data.transformId);
                try {
                    await consumer.sendData(data.data);
                    if (data.isLast) {
                        consumer.close();
                    }
                }
                catch (error) {
                    consumer.onError(error);
                }
            }
            for (const timers of elements.timers) {
                const consumer = this.getConsumer(timers.instructionId, timers.transformId);
                try {
                    await consumer.sendTimers(timers.timerFamilyId, timers.timers);
                    if (timers.isLast) {
                        consumer.close();
                    }
                }
                catch (error) {
                    consumer.onError(error);
                }
            }
        }, _tct_transform_10.__closure = () => ({ console }), _tct_transform_10));
        this.dataChannel.on("error", (_tct_transform_11 = (err) => {
            console.log("Data channel error", err);
        }, _tct_transform_11.__closure = () => ({ console }), _tct_transform_11));
    }
    close() {
        this.dataChannel.end();
    }
    async registerConsumer(bundleId, transformId, consumer) {
        consumer = truncateOnErrorDataChannel(consumer);
        if (!this.consumers.has(bundleId)) {
            this.consumers.set(bundleId, new Map());
        }
        if (this.consumers.get(bundleId).has(transformId)) {
            await this.consumers.get(bundleId).get(transformId).flush(consumer);
        }
        this.consumers.get(bundleId).set(transformId, consumer);
    }
    unregisterConsumer(bundleId, transformId) {
        this.consumers.get(bundleId).delete(transformId);
    }
    getConsumer(bundleId, transformId) {
        if (!this.consumers.has(bundleId)) {
            this.consumers.set(bundleId, new Map());
        }
        if (!this.consumers.get(bundleId).has(transformId)) {
            this.consumers.get(bundleId).set(transformId, bufferingDataChannel());
        }
        return this.consumers.get(bundleId).get(transformId);
    }
    getSendChannel(bundleId, transformId) {
        var _tct_transform_12, _tct_transform_13, _tct_transform_14;
        // TODO: (Perf) Buffer and consilidate send requests?
        // Or perhaps document that consumers of this API should so so.
        const this_ = this;
        return {
            sendData: (_tct_transform_12 = function (data) {
                this_.dataChannel.write({
                    data: [
                        {
                            instructionId: bundleId,
                            transformId: transformId,
                            data: data,
                            isLast: false,
                        },
                    ],
                    timers: [],
                });
                return Promise.resolve();
            }, _tct_transform_12.__closure = () => ({ this_, bundleId, transformId, Promise }), _tct_transform_12),
            sendTimers: (_tct_transform_13 = function (timerFamilyId, timers) {
                // Should never get here if we never send timers.
                throw Error("Timers not yet supported.");
            }, _tct_transform_13.__closure = () => ({ Error }), _tct_transform_13),
            close: (_tct_transform_14 = function () {
                this_.dataChannel.write({
                    data: [
                        {
                            instructionId: bundleId,
                            transformId: transformId,
                            data: new Uint8Array(),
                            isLast: true,
                        },
                    ],
                    timers: [],
                });
            }, _tct_transform_14.__closure = () => ({ this_, bundleId, transformId, Uint8Array }), _tct_transform_14),
            onError: function (error) {
                throw error;
            },
        };
    }
}
exports.MultiplexingDataChannel = MultiplexingDataChannel;
//# sourceMappingURL=data.js.map